#!/usr/bin/perl

use strict;

my $macosx = 1;

open OUT,">main.s" or die("can't write main.s");

my $current_macro;
my $current_body;
my %macro;
my @nest;

my $skip;
# my $fd = "in000";

foreach my $file ( @ARGV ) {
    &process($file);
}

my @ifs;

my $if;
my %sym;

sub process
{
    my ($file) = @_;

    # my $myfd = $fd++;
    my $myfd;

# if ($file =~ /vtllib/) {
#     print STDERR "hage\n";
# }

    open $myfd,"<$file"  or print STDERR "failed open $file\n";
 # || die("can't open $file : $!\n");
    while(<$myfd>) {
	next if (&remove_comment);
	if (/\.else/) {
	    $if = ($if eq 'true')?'false':'true';
	    next;
	} elsif (/\.endif/) {
	    $if = pop(@ifs);
	    next;
	} elsif (/\.ifdef\s+(\w+)/) {
	    push(@ifs,$if);
	    $if = defined($sym{$1})?"true":"false";
	    next;
	} elsif (/\.ifndef\s+(\w+)/) {
	    push(@ifs,$if);
	    $if = defined($sym{$1})?"false":"true";
# if (/__VTLLIB/) {
#     print STDERR "hoge\n";
# }
	    next;
	}
	next if ($if eq 'false');
	if (/(\w+)\s*=\s*(\w+)/) {
	    $sym{$1} = $2;
	} elsif (/\.include\s+"(.*)"/) {
	    print STDERR "including $1\n";
	    &process($1);
	    next;
	}
	if ($current_macro) {
	    if (/\.endm/) {
		$macro{$current_macro}->[1] = $current_body;
		($current_macro,$current_body) = splice(@nest,-2,2);
		$current_macro = $current_body = '';
	    } else {
		$current_body .= $_."\n";
	    }
	    next;
	}
	if (/\.macro\s+(\w+)\s+(.*)/) {
	    $macro{$1} = [$2,0];
	    push(@nest,$current_macro,$current_body);
	    $current_macro = $1;
	    $current_body = '';
	    next;
	}
	if (/\:\s+(\w+)(.*)/) { 
	    expand($1,$2);
	} elsif (/^\s+(\w+)(.*)/) { 
	    expand($1,$2);
	}
	if ($macosx) { &macosx; }
	print OUT;
	print OUT "\n";
    }
}


sub expand
{
    my ($nm,$values) = @_;
    if (defined($macro{$nm})) {
	my ($args,$body) =  @{$macro{$nm}};
	while($args=~s/(\w+)//) {
	    my $arg = $1;
	    my $value;
	    $values=~s/\s*([^,]+)//;
	    $value = $1;
	    $value =~ s/\s*$//;
	    $body =~ s/\\$arg/$value/eg;
	    $args =~s/[^,]*,//;
	    $values =~s/[^,]*,//;
	}
	$_ =~ s/$nm.*/$body/e;
    }
    return;
}

sub remove_comment
{
    chop;
    s/\r//g;
    if ($skip) {
	if (m-\*/-) {
	    $skip = 0;
	} else {
	    return 1;
	}
    }
    s/^\#.*//;
    s/([^'])#.*/$1/;
    s-/\*.*\*/--;
    $skip=1 if (m-/\*-) ;
    return 0;
}

sub macosx
{
    s/\.global/.globl/;
    s/(\ssc)$/\1\n\tnop/;
    s/\.section.*/.data/;
    s/\.skip/.space/;
    s/\s*\.equ\s+(\w+),(.*)/\1 = \2/;
    s/\.hword/.short/;
    s/(\w+)\@ha/ha16(\1)/;
    s/(\w+)\@l/lo16(\1)/;
    s/'\\\\'/ord('\\')/eg;
    s/'\\\\/ord('\\')/eg;
    s/'(.)'/ord($1)/eg;
    s/'(.)/ord($1)/eg;

}

