#-------------------------------------------------------------------------
# Return of the Very Tiny Language for PowerPC
# file : rvtl.s ver. 3.03
# 2005/04/22-2005/05/07-18,22,30,6/19
# Copyright (C) 2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
# rvtl.s may be copied under the terms of the GNU General Public License.
#-------------------------------------------------------------------------


MACOSX      =   1

ARGMAX      =   15
VSTACKMAX   =   1024
MEMINIT     =   256*1024
LSTACKMAX   =   127
FNAMEMAX    =   256
LABELMAX    =   1024
VERSION     =   30300

VTL_LABEL   =   1
#SMALL_VTL   =   1
FRAME_BUFFER=   1
#DEBUG       =   1

.ifdef SMALL_VTL
SIMPLE_MSG=1
.endif

.ifdef FRAME_BUFFER
#.include "fblib.s"
.endif

.ifdef DEBUG
.include "debug.s"
.endif

.include "signal.s"
.include "vtllib.s"
.include "mt19937.s"

#---------------------------------------------------------------
# MACRO SETVAR
#---------------------------------------------------------------
.macro SETVAR   reg, var
        li      r6, \var * 4
        stwx    \reg, r17, r6
.endm

#---------------------------------------------------------------
# MACRO GETVAR
#---------------------------------------------------------------
.macro GETVAR   reg, var
        li      r6, \var * 4
        lwzx    \reg, r17, r6
.endm

#---------------------------------------------------------------
# MACRO load 32bit immediate
#---------------------------------------------------------------
.ifndef __LWI
     __LWI = 1
    .macro  LWI    reg, symbol
        lis     \reg, \symbol@ha
        addi    \reg, \reg, \symbol@l
    .endm
.endif

#==============================================================
        .text
        .global _start
        .global _main

_start:
_main:
                .align   2
#-------------------------------------------------------------------------
# ƥν
#-------------------------------------------------------------------------
        # ޥɥ饤ΰο򥹥å [argc] ¸
.ifdef MACOSX
	# r3   argc
	# r4   argvp
	# r5   envp
        LWI     r6, argc
        stw     r3, 0(r6)               # argc ο¸
        stw     r4, 4(r6)               # argvp Ƭ¸
        stw     r5, 8(r6)               # envp Ķѿΰ¸
	mr	r4, r6
.else
        LWI     r4, argc
        lwz     r3, 0(r1)               # r3 = argc
        stw     r3, 0(r4)               # argc ο¸
        addi    r5, r1, 4
        stw     r5, 4(r4)               # argvp Ƭ¸

        # ĶѿǼɥ쥹 [envp] ¸
        slwi    r3, r3, 2               # r3 = argc * 4
        add     r5, r5, r3
        addi    r5, r5, 4               # Ķѿɥ쥹
        stw     r5, 8(r4)               # envp Ķѿΰ¸
.endif

        # ޥɥ饤ΰ
        lwz     r6, 0(r4)               # r6 = argc
        lwz     r9, 4(r4)               # r9 = argvp
        li      r3, 1
        cmpw    r6, r3
        beq     4f                      # ʤ(argc=1)ʤ饹å
    1:
        slwi    r5, r3, 2               # r5 = argc * 4
        lwzx    r7, r9, r5              # r7 = &argvp[r3]
        lbz     r8, 0(r7)               # 1ʸ
        addi    r3, r3, 1
        cmpw    r3, r6
        beq     2f                      # Ǹΰޤǥå
        cmpwi   r8, '-                  # -פ
        bne     1b
        subi    r3, r3, 1
        stw     r3, 0(r4)               # argc ο򹹿
        addi    r3, r3, 1
    2:  slwi    r5, r3, 2
        add     r5, r9, r5              # r5 = &argvp[r3]
        stw     r5, 16(r4)              # vtlѤΰʸؤƬ
        sub     r3, r6, r3
        stw     r3, 12(r4)              # vtlѤΰθĿ (argc_vtl)

    4:  # argv[0]="xxx/rvtlw" ʤ cgi⡼
        li      r5, 0
        LWI     r3, cginame             # ʸ 'wltvr',0
        lwz     r4, 0(r9)               # argv[0]
        subi    r4, r4, 1
    5:  lbzu    r0, 1(r4)
        cmpwi   r0, 0
        bne     5b
        subi    r3, r3, 1
    6:  lbzu    r0, -1(r4)              # argv[0]
        lbzu    r6, 1(r3)               # 'wltvr',0
        cmpwi   r6, 0
        beq     7f                      # found
        cmpw    r0, r6
        bne     8f                      # no
        b       6b
    7:  li      r5, 1
    8:  LWI     r3, cgiflag
        stw     r5, 0(r3)

        # ߤü(termios) ¸ü륨OFF˺

        bl      GET_TERMIOS             # termios ¸
        bl      SET_TERMIOS             # üΥ륨OFF

        # r17ѿΰƬɥ쥹ꡢѿΥr17ȤäƹԤ

        LWI     r17, VarArea            # ѿΰƬ

        # ƥѿνͤ

        LWI     r9, CodeArea
        SETVAR  r9, ',                  # ץƬ
        SETVAR  r9, '=                  # ץƬ
        li      r3, -1                  # -1
        stw     r3, 0(r9)               # ޡ
        addi    r9, r9, 4               # ҡƬ
        SETVAR  r9, '&
        li      r3, 0                   # 0 ϤƸͤ
.ifdef MACOSX
        li      r0, sys_sbrk             # brk
.else
        li      r0, sys_brk             # brk
.endif
        sc
        SETVAR  r3, '*                  # RAM

        LWI     r3, 672274774           # 
        SETVAR  r3, '`                  # 
        bl      sgenrand

        # ctrl-C, ctrl-ZѤΥʥϥɥϿ
        LWI     r4, new_sig             # r4=new_sig
        LWI     r3, SigIntHandler       # ʥϥɥ
        stw     r3, 0(r4)               # nsa_sighandler
        li      r0, 0
        stw     r0, 4(r4)               # nsa_mask
        stw     r0, 12(r4)              # nsa_restorer
        li      r0, SA_NOCLDSTOP        # ҥץߤ̵
        stw     r0, 8(r4)               # nsa_flags
        li      r3, SIGINT              # ^C
        addi    r5, r4, 16              # old_sig
        li      r0, sys_sigaction
        sc
        li      r0, SIG_IGN             # ʥ̵
.ifdef MACOSX
        LWI     r4, new_sig             # r4=new_sig
.endif
        stw     r0, 0(r4)               # nsa_sighandler
        li      r3, SIGTSTP             # ^Z
        li      r0, sys_sigaction
        sc

        # PID¸(initμ)pid=1 ʤĶѿ
        li      r0, sys_getpid
        sc
        stw     r3, -24(r17)            # pid ¸
        cmpwi   r3, 1
        bne     1f

        LWI     r4, envp                # pid=1 ʤĶѿ
        LWI     r3, env                 # envp Ķѿ
        stw     r3, 0(r4)

        # /etc/init.vtl¸ߤɤ߹
        LWI     r3, initvtl             # /etc/init.vtl
        bl      fropen                  # open
        bso     1f                      # ̵з³
        stw     r3, -8(r17)             # FileDesc
        bl      WarmInit2
        li      r0, 1
        stb     r0, -4(r17)             # Read from file
        li      r14, 1                  # EOL=yes
        b       Launch
    1:
        bl      WarmInit2
        li      r0, 0
        LWI     r3, current_arg
        stw     r0, 0(r3)               # ѰȽ
        bl      LoadCode                # Хץ
        bns     Launch

.ifndef SMALL_VTL
        LWI     r3, start_msg           # ưå
        bl      OutAsciiZ
.endif

Launch:             # λ
        LWI     r3, save_stack
        stw     r1, 0(r3)               # å¸

#-------------------------------------------------------------------------
# ᥤ롼
#-------------------------------------------------------------------------
MainLoop:
        # SIGINT(ctrl-Cβ)򸡽Ф֤᤹
        lbz     r0, -17(r17)
        cmpwi   r0, 1                   # SIGINT ?
        bne     1f
        bl      WarmInit                # ¹
        b       3f

        # 0顼ȯåɽ
    1:  lbz     r0, -18(r17)            # 顼
        cmpwi   r0, 1
        bne     2f
        LWI     r3, err_div0            # 0å
        bl      OutAsciiZ
        bl      WarmInit                # ¹

        # ǥ顼򸡽Фåɽ
    2:  lbz     r0, -19(r17)            # ˥顼?
        cmpwi   r0, 0
        beq     3f
        b       Exp_Error               # ǥ顼ȯ

        # å (ľ EOL=1)
    3:  cmpwi   r14, 0                  # EOL
        beq     4f

        # Լ (󥽡ϤޤϥΥץ)
        lbz     r0, -3(r17)
        cmpwi   r0, 1                   # ExecMode=Memory ?
        bne     ReadLine                # Լ
        b       ReadMem                 # ꤫Լ

        # ʤɤФ
    4:  bl      GetChar
    5:  cmpwi   r10, ' '                # ɤФ
        bne     6f
        bl      GetChar
        b       5b

        # ֹդʤԽ⡼
    6:
        bl      IsNum                   # ֹդʤԽ⡼
        bso     7f
        bl      EditMode                # Խ⡼
        b       MainLoop

        # ʸʤѿۤʤХޥ
    7:  bl      IsAlpha
        bso     Command                 # ޥɼ¹
    8:  bl      SetVar                  # ѿ
        b       MainLoop

LongJump:
        LWI     r3, save_stack
        lwz     r1, 0(r3)               # å
        LWI     r3, err_exp             # ˶
        b       Error
Exp_Error:
        cmpwi   r0, 2
        bne     1f
        LWI     r3, err_vstack          # ѿåե
        b       Error
    1:  LWI     r3, err_label           # ٥̤å
        b       Error

#-------------------------------------------------------------------------
# ʥϥɥ
#-------------------------------------------------------------------------
SigIntHandler:
        li      r0, 1                   # SIGINT ʥ
        stb     r0, -17(r17)            # r17ϾƱ
        blr

#-------------------------------------------------------------------------
# ޥɥ饤ǻꤵ줿VTLɥե
# ¹Ը塢so=0 ʤ
#-------------------------------------------------------------------------
LoadCode:
        subi    r1, r1, 20
        stswi   r3, r1, 20              # push r3-r7
        mflr    r7                      # save lr
        LWI     r3, current_arg         # Ѥߤΰ
        lwz     r4, 0(r3)
        addi    r4, r4, 1               # ȥå
        lwz     r5, 4(r3)               # argc θĿ
        cmpw    r4, r5
        bne     0f                      # 
        creqv   3, 8, 8                 # cr0[so]=1
        b       3f                      # ٤ƽѤ
    0:
        stw     r4, 0(r3)               # Ѥߤΰ
        lwz     r5, 8(r3)               # argvp Ƭ
        slwi    r4, r4, 2
        lwzx    r3, r5, r4              # ɥ쥹
        LWI     r4, FileName
        li      r5, FNAMEMAX
        mtctr   r5
        li      r6, 0
    1:  lbzx    r5, r3, r6              # 򥳥ԡ
        stbx    r5, r4, r6              # FileName
        addi    r6, r6, 1
        and.    r5, r5, r5              # ʸå
        beq     2f                      # file open
        bdnz    1b

    2:  LWI     r3, FileName            # ե륪ץ
        bl      fropen                  # open
        bso     3f
        stw     r3, -8(r17)             # FileDesc
        li      r0, 1
        stb     r0, -4(r17)             # Read from file
        li      r14, 1                  # EOL=yes
    3:
        mtlr    r7                      # restore lr
        lswi    r3, r1, 20              # pop r3-r7
        addi    r1, r1, 20              # restore r1
        blr

#-------------------------------------------------------------------------
# ʸ " ޤ EOL ޤ FileName ˥ԡ
#-------------------------------------------------------------------------
GetString:
        mflr    r3                      # save lr
        stwu    r3, -4(r1)              # push r3
        li      r4, 0
        LWI     r3, FileName
    1: # next:
        bl      GetChar
        cmpwi   r10, '"'                # " ?
        beq     2f
        and.    r10, r10, r10           # (0) ?
        beq     2f
        stbx    r10, r3, r4
        addi    r4, r4, 1
        cmpwi   r4, FNAMEMAX
        blt     1b
    2: # exit:
        li      r10, 0
        stbx    r10, r3, r4             # (0)
        lwz     r3, 0(r1)               # pop lr
        mtlr    r3                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# r0 Υɥ쥹FileName˥ԡ
#-------------------------------------------------------------------------
  GetString2:
        mflr    r3                      # save lr
        stwu    r3, -4(r1)              # push r3
        mr      r5, r0
        li      r4, 0
        LWI     r3, FileName
    1:  lbzx    r6, r5, r4
        stbx    r6, r3, r4
        and.    r6, r6, r6
        beq     2f
        addi    r4, r4, 1
        cmpwi   r4, FNAMEMAX
        blt     1b
    2:
        lwz     r3, 0(r1)               # pop lr
        mtlr    r3                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ե̾Хåե˼
# ХåեƬɥ쥹 r3 ֤
#-------------------------------------------------------------------------
GetFileName:
        mflr    r4                      # save lr
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # skip =
        cmpwi   r10, '='
        bne     2f                      # 顼
        bl      GetChar                 # skip "
        cmpwi   r10, '"'
        beq     1f
        b       2f                      # 顼
    1: # file
        bl      GetString
        LWI     r3, FileName            # ե̾ɽ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    2: # error
        addi    r1, r1, 4               # å
        b       pop_and_Error

#-------------------------------------------------------------------------
# ϤޤϥեϤ줿ɤ¹
#-------------------------------------------------------------------------
ReadLine:
            # 1 : ϤȥեϤб
        lbz     r0, -4(r17)             # Read from console
        cmpwi   r0, 0
        beq     1f                      # 󥽡뤫
        bl      READ_FILE               # ե뤫
        b       MainLoop

    1:  # ץץȤɽƥ󥽡뤫饭
        bl      DispPrompt
        LWI     r4, input
        li      r3, MAXLINE             # 1 
        bl      READ_LINE               # Խǽե
        mr      r12, r4                 # ϥХåեƬ
        mr      r11, r12
        li      r14, 0                  # not EOL
        b       MainLoop

#-------------------------------------------------------------------------
# ˳Ǽ줿ɤμԤr12
# r11 : Ƭɥ쥹
#-------------------------------------------------------------------------
ReadMem:
        lwz     r3, 0(r11)              # JUMP褫⤷ʤ
        addic.  r3, r3, 1               # ԥեåȤ -1 ?
        beq     1f                      # ʤ¹Խλ
        lwz     r3, 0(r11)
        add     r11, r11, r3            # Next Line

        #ԤؤΥեåȤ0ʤХ
        lwz     r3, 0(r11)              # ԥեå
        and.    r3, r3, r3              # 
        bgt     2f

        #ʤХ󥽡(쥯ȥ⡼)ꤷ
        #EOL1Ȥ뤳ȤǡԼ¥
    1:
        bl      CheckCGI                # CGI⡼ɤʤ齪λ
        li      r0, 0
        li      r9, 1
        stb     r0, -3(r17)             # ExecMode=Direct
        li      r14, 1                  # EOL=yes
        b       MainLoop

        #ߤιֹ # ꤷơԤΥʬƬɥ쥹 r12 
    2:
        bl      SetLineNo               # ֹ # 
        addi    r12, r11, 8             # ԤΥƬ
        li      r14, 0                  # EOL=no
        b       MainLoop

#-------------------------------------------------------------------------
# ʸμ¹
#   ʸ¹Ԥ륵֥롼򥳡
#-------------------------------------------------------------------------
Command:
        #r10쥸ͤˤäƳƽ롼ƤӽФ
        subic.  r9, r10, '!
        blt     1f
        cmpwi   r9, '/- '!
        bgt     1f
        LWI     r3, TblComm1            # ץơ֥1 !-/
        slwi    r9, r9, 2
        lwzx    r9, r3, r9              # 襢ɥ쥹
        mtctr   r9
        bctrl                           # б롼򥳡
        b       MainLoop
    1:  subic.  r9, r10, ':'
        blt     2f
        cmpwi   r9, '@ - ':
        bgt     2f
        LWI     r3, TblComm2            # ץơ֥2 :-#
        slwi    r9, r9, 2
        lwzx    r9, r3, r9              # 襢ɥ쥹
        mtctr   r9
        bctrl                           # б롼򥳡
        b       MainLoop
    2:  subic.  r9, r10, '['
        blt     3f
        cmpwi   r9, '` - '[
        bgt     3f
        LWI     r3, TblComm3            # ץơ֥3 0(-`
        slwi    r9, r9, 2
        lwzx    r9, r3, r9              # 襢ɥ쥹
        mtctr   r9
        bctrl                           # б롼򥳡
        b       MainLoop
    3:  subic.  r9, r10, '{'
        blt     4f
        cmpwi   r9, '~ - '{
        bgt     4f
        LWI     r3, TblComm4            # ץơ֥4 {-~
        slwi    r9, r9, 2
        lwzx    r9, r3, r9              # 襢ɥ쥹
        mtctr   r9
        bctrl                           # б롼򥳡
        b       MainLoop
    4:  cmpwi   r10, ' '
        beq     MainLoop
        cmpwi   r10, 0
        beq     MainLoop
        cmpwi   r10, 8
        beq     MainLoop
        b       SyntaxError

#-------------------------------------------------------------------------
# ɤ1ʸɤ߹
# r12 μʸ r10 ɤ߹, r12 򼡤ΰ֤˹
# (r10=0)ʤ r14(EOLե饰)  1 񤭹
# 쥸¸
#-------------------------------------------------------------------------
GetChar:
        cmpwi   r14, 1                  # EOL=yes?
        beq     3f
        lbz     r10, 0(r12)             # getchar
        and.    r10, r10, r10
        bne     2f
        li      r14, 1
    2:  addi    r12, r12, 1
    3:  blr

#-------------------------------------------------------------------------
# ֹ򥷥ƥѿ # 
#-------------------------------------------------------------------------
SetLineNo:
        lwz     r3, 4(r11)              # Line No.
        SETVAR  r3, '#
        blr

#-------------------------------------------------------------------------
# ʸˡ顼
#-------------------------------------------------------------------------
SyntaxError:
        LWI     r3, syntaxerr
Error:  bl      OutAsciiZ
        lbz     r3, -3(r17)
        and.    r3, r3, r3              # ExecMode=Direct ?
        beq     3f
        lwz     r3, 4(r11)              # 顼Թֹ
        bl      PrintLeft
        bl      NewLine
        addi    r3, r11, 8              # Ƭɥ쥹
    5:  bl      OutAsciiZ               # 顼ɽ
        bl      NewLine
        sub     r3, r12, r11
        subic.  r4, r3, 9
        beq     2f
        cmpwi   r3, MAXLINE
        bgt     3f
        li      r3, ' '                 # 顼
    1:  bl      OutChar
        subic.  r4, r4, 1
        bne     1b
    2:  LWI     r3, err_str
        bl      OutAsciiZ
        mr      r3, r10
        bl      PrintHex2               # 顼ʸɽ
        li      r3, ']'
        bl      OutChar
        bl      NewLine

    3:  bl      WarmInit                # ƥ֤
        b       MainLoop

#-------------------------------------------------------------------------
# ѿåϰϥ顼
#-------------------------------------------------------------------------
VarStackError_over:
        LWI     r3, vstkover
        b       1f
VarStackError_under:
        LWI     r3, vstkunder
    1:
        mflr    r4
        stwu    r4, -4(r1)
        bl      OutAsciiZ
        bl      WarmInit
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# åإɥ쥹ץå (Ԥʸ֤)
#-------------------------------------------------------------------------
PushLine:
        subi    r1, r1, 16
        stswi   r3, r1, 16              # push r3-r6
        lbz     r3, -1(r17)             # LSTACK
        cmpwi   r3, LSTACKMAX
        bge     StackError_over         # overflow
        addi    r4, r17, 512            # (r17 + 512) + LSTACK*4
        slwi    r6, r3, 2
        stwx    r11, r4, r6             # push r11

        addi    r3, r3, 1               # LSTACK++
        slwi    r6, r3, 2
        lbz     r5, -1(r12)
        cmpwi   r5, 0
        beq     1f                      # 
        stwx    r12, r4, r6             # push r12,(r17+512)+LSTACK*4
        b       2f
    1:
        subi    r12, r12, 1             # 1ʸ᤹
        stwx    r12, r4, r6             # push r12,(r17+512)+LSTACK*4
        addi    r12, r12, 1             # 1ʸʤ
    2:
        addi    r3, r3, 1               # LSTACK++
        stb     r3, -1(r17)             # LSTACK
        lswi    r3, r1, 16              # pop r3-r6
        addi    r1, r1, 16              # restore r1
        blr

#-------------------------------------------------------------------------
# å饢ɥ쥹ݥå (Ԥʸ֤)
# r11, r12 
#-------------------------------------------------------------------------
PopLine:
        subi    r1, r1, 16
        stswi   r3, r1, 16              # push r3-r6
        lbz     r3, -1(r17)             # LSTACK
        cmpwi   r3, 2
        blt     StackError_under        # underflow
        subi    r3, r3, 1               # LSTACK--
        addi    r5, r17, 512            # (r17 + 512) + LSTACK*4
        slwi    r6, r3, 2
        add     r5, r5, r6
        lwz     r12, 0(r5)              # pop r12
        lwz     r11, -4(r5)             # pop r11
        subi    r3, r3, 1               # LSTACK--
        stb     r3, -1(r17)             # LSTACK
        lswi    r3, r1, 16              # pop r3-r6
        addi    r1, r1, 16              # restore r1
        blr

#-------------------------------------------------------------------------
# å顼
# r3 ѹ
#-------------------------------------------------------------------------
StackError_over:
        LWI     r3, stkover
        b       1f
StackError_under:
        LWI     r3, stkunder
    1:
        mflr    r4
        stwu    r4, -4(r1)
        bl      OutAsciiZ
        bl      WarmInit
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# åؽλ(r0)ץå
#-------------------------------------------------------------------------
PushValue:
        lbz     r3, -1(r17)             # LSTACK
        cmpwi   r3, LSTACKMAX
        bge     StackError_over
        addi    r5, r17, 512            # (r17 + 512) + LSTACK*4
        slwi    r6, r3, 2
        stwx    r0, r5, r6              # push r0
        addi    r3, r3, 1               # LSTACK++
        stb     r3, -1(r17)             # LSTACK
        blr

#-------------------------------------------------------------------------
# åνλ r0 
#-------------------------------------------------------------------------
PeekValue:
        subi    r1, r1, 8
        stswi   r3, r1, 8               # push r3-r4

        lbz     r3, -1(r17)             # LSTACK
        subi    r3, r3, 3               # ,ʸ֤
        addi    r4, r17, 512            # (r17 + 512) + LSTACK*4
        slwi    r3, r3, 2
        lwzx    r0, r4, r3              # read Value

        lswi    r3, r1, 8               # pop r3-r4
        addi    r1, r1, 8               # restore r1
        blr

#-------------------------------------------------------------------------
# å齪λ(r0)ݥå
#-------------------------------------------------------------------------
PopValue:
        lbz     r3, -1(r17)             # LSTACK
        cmpwi   r3, 1
        blt     StackError_under
        subi    r3, r3, 1               # LSTACK--
        addi    r5, r17, 512            # (r17 + 512) + LSTACK*4
        slwi    r6, r3, 2
        lwzx    r0, r5, r6              # pop r0
        stb     r3, -1(r17)             # LSTACK
        blr

#-------------------------------------------------------------------------
# ץץɽ
#-------------------------------------------------------------------------
DispPrompt:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      WinSize
        srwi    r0, r0, 16              # 
        cmpwi   r0, 48
        blt     1f
        li      r3, 7                   # long prompt
        bl      set_linetop             # Ƭޡ
        LWI     r3, prompt1             # ץץɽ
        bl      OutAsciiZ
        lwz     r3, -24(r17)            # pid μ
.ifdef DEBUG
        mr      r3, r1                  # sp β4
.endif
        bl      PrintHex4
        LWI     r3, prompt2             # ץץɽ
        bl      OutAsciiZ
        b       2f

    1:  li      r3, 4                   # short prompt
        bl      set_linetop             # Ƭޡ
        bl      NewLine
        lwz     r3, -24(r17)            # pid μ
        bl      PrintHex2               # pidβ1ɽ
        LWI     r3, prompt2             # ץץɽ
        bl      OutAsciiZ
    2:  lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ϰϥ顼
#-------------------------------------------------------------------------
RangeError:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        LWI     r3, Range_msg           # ϰϥ顼å
        bl      OutAsciiZ
        GETVAR  r3, '#                  # ֹ
        bl      PrintLeft
        bl      WarmInit
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# CGI ⡼ɤʤ rvtl λ
#-------------------------------------------------------------------------
CheckCGI:
        LWI     r3, cgiflag
        lwz     r3, 0(r3)
        cmpwi   r3, 1                   # CGI mode ?
        beq     Com_Exit
        blr

#-------------------------------------------------------------------------
# ƥ
#-------------------------------------------------------------------------
        #ޥϸ򥳥󥽡

WarmInit:
        mflr    r4
        bl      CheckCGI                # CGI⡼ɤʤ齪λ
        mtlr    r4

WarmInit2:
        li      r0, 0                   # 0
        stb     r0, -4(r17)             # Read from console

        #ƥѿڤӺѥե饰ν
WarmInit1:
        li      r0, 1                   # 1
        SETVAR  r0, '[                  # ϰϥåON
        mr      r14, r0                 # EOL=no
        li      r0, 0                   # 0
        LWI     r3, exarg               # execve 
        stw     r0, 0(r3)
        stb     r0, -19(r17)            # Υ顼̵
        stb     r0, -18(r17)            # ̵
        stb     r0, -17(r17)            # SIGINTʥ̵
        stb     r0, -3(r17)             # ExecMode=Direct
        stb     r0, -1(r17)             # LSTACK
        stw     r0, -16(r17)            # VSTACK
        blr

#-------------------------------------------------------------------------
# GOSUB !
#-------------------------------------------------------------------------
Com_GOSUB:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lbz     r3, -3(r17)
        and.    r3, r3, r3              # ExecMode=Direct ?
        bne     1f
        LWI     r3, no_direct_mode
        bl      OutAsciiZ
        addi    r1, r1, 4               # å
        bl      WarmInit
        b       MainLoop
    1:
.ifdef VTL_LABEL
        bl      ClearLabel
.endif
        bl      SkipEqualExp           # = ɤФ ɾ
        bl      PushLine
        bl      Com_GO_go
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# Return )
#-------------------------------------------------------------------------
Com_Return:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      PopLine                 # ߹Ԥθ̵
        li      r14, 0                  # not EOL
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# IF #  :
#-------------------------------------------------------------------------
Com_IF:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        and.    r0, r0, r0
        beq     Com_Comment
        blr                             # ʤ롢ʤ鼡
Com_Comment:
        li      r14, 1                  # EOL=yes ιԤ
        blr

#-------------------------------------------------------------------------
# ̤ޥɽ(顼ȥå)
#-------------------------------------------------------------------------
pop2_and_Error:
        addi    r1, r1, 4
pop_and_Error:
        addi    r1, r1, 4
Com_Error:
        b       SyntaxError

#-------------------------------------------------------------------------
# DO UNTIL NEXT #
#-------------------------------------------------------------------------
Com_DO:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lwz     r0, -3(r17)
        cmpwi   r0, 0                   # ExecMode=Direct ?
        bne     1f
        LWI     r3, no_direct_mode
        bl      OutAsciiZ
        addi    r1, r1, 4               # å
        bl      WarmInit
        b       MainLoop
    1:
        bl      GetChar
        cmpwi   r10, '='
        bne     7f                      # DO ޥ
        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, '('                # UNTIL?
        bne     2f                      # ( Ǥʤ NEXT
        bl      SkipCharExp             # (ɤФƼɾ
        mr      r5, r0                  # 
        bl      GetChar                 # ) ɤ(Ȥʤ)
        bl      PeekValue               # λ
        cmpw    r5, r0                  # r0:λ
        bne     6f                      # continue
        b       5f                      # 롼׽λ

    2: # next (FOR)
        bl      IsAlpha                 # al=0(A-Za-z) ?
        bso     pop_and_Error           # å SyntaxError
        slwi    r6, r10, 2
        add     r4, r17, r6             # ѿΥɥ쥹
        bl      Exp                     # Ǥդμ
        lwz     r3, 0(r4)               # ͤ r3 
        stw     r0, 0(r4)               # ѿι
        mr      r5, r0                  # μͤr5
        bl      PeekValue               # λ r0 
        lbz     r9, -20(r17)
        cmpwi   r9, 1                   # ߽ ( > λ)
        bne     4f                      # 

    3: # ߽
        cmpw    r3, r5                  #  - 
        ble     pop_and_Error           # Х顼
        cmpw    r3, r0                  # r0:λ
        bgt     6f                      # continue
        b       5f                      # λ

    4: # 
        cmpw    r3, r5                  #  - 
        bge     pop_and_Error           # 礭Х顼
        cmpw    r3, r0                  # r0:λ
        blt     6f                      # continue

    5: # exit 롼׽λ
        lbz     r3, -1(r17)             # LSTACK=LSTACK-3
        subi    r3, r3, 3
        stb     r3, -1(r17)             # LSTACK
        b       8f

    6: # continue UNTIL
        lbz     r3, -1(r17)             # LSTACK ꥢɥ쥹
        subi    r3, r3, 1
        slwi    r6, r3, 2
        add     r4, r17, r6
        addi    r4, r4, 512
        lwz     r12, 0(r4)              # r17+(r3-1)*4+512
        subi    r3, r3, 1
        slwi    r6, r3, 2
        add     r4, r17, r6
        addi    r4, r4, 512
        lwz     r11, 0(r4)              # r17+(r3-2)*4+512
        li      r14, 0                  # not EOL
        b       8f

    7: # do
        li      r0, 1                   # DO
        bl      PushValue
        bl      PushLine

    8:  lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿؤ, FORʸ
# r10 ѿ̾ꤷƸƤӽФ
#-------------------------------------------------------------------------
SetVar:         # ѿ
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipAlpha               # ѿξĹʬɤФ
        slwi    r6, r9, 2               # r9ѿ
        add     r13, r17, r6            # ѿΥɥ쥹
        cmpwi   r10, '('
        beq     s_array1                # 1Х
        cmpwi   r10, '{'
        beq     s_array2                # 2Х
        cmpwi   r10, '['
        beq     s_array4                # 4Х
        cmpwi   r10, '*
        beq     s_strptr                # ݥ󥿻
        cmpwi   r10, '=
        bne     pop_and_Error

        # ñѿ
    0:  bl      Exp                     # ν(ɤ̵ǸƤ)
        stw     r0, 0(r13)              # 
        mr      r9, r0
        cmpwi   r10, ','                # FORʸ?
        bne     s_exit                  # λ

        lbz     r0, -3(r17)             # ExecMode=Direct ?
        cmpwi   r0, 0
        bne     1f                      # ¹ԻʤOKʤΤFOR
        LWI     r3, no_direct_mode      # 顼ɽ
        bl      OutAsciiZ
        addi    r1, r1, 4               # å(pop)
        bl      WarmInit
        b       MainLoop                # 

    1:  # for
        li      r0, 0
        stb     r0, -20(r17)            # (0)
        bl      Exp                     # λͤr0
        cmpw    r0, r9                  # ͤȽλͤ
        bge     2f
        li      r4, 1
        stb     r4, -20(r17)           # ߽ ( >= λ)
    2:
        bl      PushValue               # λͤ(NEXTȽ)
        bl      PushLine                # Forʸľ
    3:
        b       s_exit

    s_array1:
        bl      s_array
        bso     s_range_err             # ϰϳ򥢥
        stbx    r0, r13, r9             # 
        b       s_exit

    s_array2:
        bl      s_array
        bso     s_range_err             # ϰϳ򥢥
        slwi    r9, r9, 1
        sthx    r0, r13, r9             # 
        b       s_exit

    s_array4:
        bl      s_array
        bso     s_range_err             # ϰϳ򥢥
        slwi    r6, r9, 2
        stwx    r0, r13, r6             # 
        b       s_exit

    s_strptr:                           # ʸ򥳥ԡ
        bl      GetChar                 # skip =
        lwz     r13, 0(r13)             # ѿˤϥԡ
        bl      RangeCheck              # ԡϰϥå
        bso     s_range_err             # ϰϳ򥢥
        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, '"
        bne     s_sp0

        li      r4, 0                   # ʸ˥ԡ
        bl      GetChar                 # skip "
    1:                                  # next char
        bl      GetChar
        cmpwi   r10, '"
        beq     2f
        and.    r10, r10, r10
        beq     2f
        stbx    r10, r13, r4
        addi    r4, r4, 1
        cmpwi   r4, FNAMEMAX
        blt     1b
    2:                                  # done
        li      r10, 0
        stbx    r10, r13, r4
        SETVAR  r4, '%                  # % ʸ
        b       s_exit

    s_sp0:
        bl      Exp                     # ԡΥɥ쥹
        mr      r3, r0
        cmplw   r3, r13
        beq     3f
        mr      r4, r13                 # r13
        mr      r13, r0                 # RangeCheckr13򸫤
        bl      RangeCheck              # ԡϰϥå
        mr      r13, r4                 # ԡ
        bso     s_range_err             # ϰϳ򥢥
        li      r4, 0
        LWI     r6, 0x40000             # ԡХȿ 256KB

    1:  lbzx    r9, r3, r4
        stbx    r9, r13, r4
        addi    r4, r4, 1
        cmplw   r4, r6                  # 262144ʸޤ
        beq     2f
        and.    r9, r9, r9              # 0 å
        bne     1b

    2:  subi    r4, r4, 1               # ʸ
        SETVAR  r4, '%                  # % ʸ
        b       s_exit

    3:  bl      StrLen
        SETVAR  r0, '%                  # % ʸ
        b       s_exit

    s_array:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      Exp                     # 󥤥ǥå
        mr      r9, r0
        lwz     r13, 0(r13)
        bl      SkipCharExp             # ν(ɤ̵ǸƤ)
        bl      RangeCheck              # ϰϥå
        b       s_exit

    s_range_err:
        bl      RangeError              # ǽϰϤĶ
    s_exit:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ΥǽϰϤå
# , < r13 < *
#-------------------------------------------------------------------------
RangeCheck:
        subi    r1, r1, 8
        stswi   r3, r1, 8               # push r3-r4

        GETVAR  r3, '[                  # ϰϥåե饰
        and.    r3, r3, r3
        beq     2f                      # 0 ʤåʤ
        LWI     r3, input2              # ץåȥХåեOK
        cmpw    r13, r3
        bne     1f
        crxor   3, 8, 8                 # cr0[so] = 0
        b       2f

    1:  GETVAR  r3, ','                 # ץƬ
        GETVAR  r4, '*'                 # RAM
        cmpw    cr2, r13, r3            # if  r3 > r13 stc
        cmpw    cr3, r13, r4            # if r13 > r4 stc
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]

    2:  lswi    r3, r1, 8               # pop r3-r4
        addi    r1, r1, 8               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿξĹʬɤФ
#   ѿ̾ r9 , ʸ r10 ֤
#   SetVar, Variable ǻ
#-------------------------------------------------------------------------
SkipAlpha:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        mr      r9, r10                 # ѿ̾ r9 
    1:  bl      GetChar
        bl      IsAlpha
        bns     1b
    2:  lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# SkipEqualExp  = ³ɾ
# SkipCharExp   1ʸɤФ ɾ
# Exp           ɾ
# r0 ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
#-------------------------------------------------------------------------
SkipEqualExp:
        stwu    r4, -4(r1)              # push r4
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # check = (r4¸)
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        lwzu    r4, 4(r1)               # pop r4
        addi    r1, r1, 4               # restore r1

SkipEqualExp2:
        cmpwi   r10, '='                # ɤߤλ
        beq     Exp                     # = ǧ
        LWI     r3, equal_err           #
        bl      OutAsciiZ               # ʤΤ lr ¸
        b       pop_and_Error           # ʸˡ顼

SkipCharExp:
        stwu    r4, -4(r1)              # push r4
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # skip a character
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        lwzu    r4, 4(r1)               # pop r4
        addi    r1, r1, 4               # restore r1

Exp:
        subi    r1, r1, 28
        stswi   r3, r1, 28              # push r3-r9
        mflr    r5                      # save lr
        stwu    r5, -4(r1)

        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, ' '
        bne     e_ok
        li      r9, 1
        stb     r9, -19(r17)            # ζϥ顼
        b       LongJump                # 顼

    e_ok:
        ## 쥸¸θƤ
        bl      Factor                  # r9 ˹
        mr      r0, r9                  # Τߤξ
    e_next:
        mr      r9, r0                  # ޤǤη̤r9˳Ǽ
        cmpwi   r10,  '+'               # ADD
        bne     e_sub
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        add     r0, r3, r9              # 2û
        b       e_next
    e_sub:
        cmpwi   r10,  '-'               # SUB
        bne     e_mul
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        sub     r0, r3, r9              # फ鱦򸺻
        b       e_next
    e_mul:
        cmpwi   r10,  '*'               # MUL
        bne     e_div
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        mullw   r0, r3, r9              # फ鱦򸺻
        b       e_next
    e_div:
        cmpwi   r10,  '/'               # DIV
        bne     e_udiv
        mr      r3, r9                  # ͤ
        and.    r3, r3, r3
        li      r4, 0                   # 
        bge     1f
        neg     r3, r3                  # r3 = -r3
        li      r4, 1                   # 
    1:  bl      Factor                  # 
        and.    r9, r9, r9
        bne     e_div1
        li      r4, 1
        stb     r4, -18(r17)            # 顼
        b       e_exit
    e_div1:
        li      r5, 0                   # 
        bge     2f
        neg     r9, r9                  # r9 = -r9
        li      r5, 1                   # 
    2:  mr      r0, r3
        divw    r0, r0, r9              # r0/r9 = r0...r9
        mullw   r9, r0, r9
        subf    r9, r9, r3
        cmpwi   r4, 0
        beq     3f
        neg     r9, r9                  # r9 = -r9
    3:  cmpw    r5, r4                  #
        beq     4f
        neg     r0, r0                  # r0 = -r0
    4:  SETVAR  r9, '%'                 # ;¸
        mr      r9, r0                  #  r9 
        b       e_next
    e_udiv:
        cmpwi   r10,  '\\'              # UDIV
        bne     e_and
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        and.    r9, r9, r9
        bne     e_udiv1
        li      r4, 1
        stb     r4, -18(r17)            # 顼
        b       e_exit
    e_udiv1:
        mr      r0, r3
        divwu   r0, r0, r9              # r0/r9 = r0...r9
        mullw   r9, r0, r9
        subf    r9, r9, r3
        SETVAR  r9, '%'                 # ;¸
        mr      r9, r0                  #  r9 
        b       e_next
    e_and:
        cmpwi   r10, '&'                # AND
        bne     e_or
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        and     r0, r3, r9
        b       e_next
    e_or:
        cmpwi   r10,  '|'               # OR
        bne     e_xor
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        or      r0, r3, r9              # ȱ OR
        b       e_next
    e_xor:
        cmpwi   r10, '^'                # XOR
        bne     e_equal
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        xor     r0, r3, r9              # ȱ XOR
        b       e_next
    e_equal:
        cmpwi   r10, '='                # =
        bne     e_exp7
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r9, r3                  # ȱ
        bne     e_false
    e_true:
        li      r0, 1
        b       e_next
    e_false:
        li      r0, 0                   # 0:
        b       e_next
    e_exp7:
        cmpwi   r10, '<'                # <
        bne     e_exp8
        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, '='                # <=
        beq     e_exp71
        cmpwi   r10, '>'                # <>
        beq     e_exp72
        cmpwi   r10, '<'                # <<
        beq     e_shl
                                        # <
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r3, r9                  # ȱ
        bge     e_false
        b       e_true
    e_exp71:
        bl      GetChar                 # <=
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r3, r9                  # ȱ
        bgt     e_false
        b       e_true
    e_exp72:
        bl      GetChar                 # <>
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r3, r9                  # ȱ
        beq     e_false
        b       e_true
    e_shl:
        bl      GetChar                 # <<
        cmpwi   r10, '<'                #
        bne     e_exp9
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        slw     r0, r3, r9              # 򱦹 SHL (*2)
        b       e_next
    e_exp8:
        cmpwi   r10, '>'                # >
        bne     e_exp9
        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, '='                # >=
        beq     e_exp81
        cmpwi   r10,  '>'               # >>
        beq     e_shr
                                        # >
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r3, r9                  # ȱ
        ble     e_false
        b       e_true
    e_exp81:
        bl      GetChar                 # >=
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        cmpw    r3, r9                  # ȱ
        blt     e_false
        b       e_true
    e_shr:
        bl      GetChar                 # >>
        mr      r3, r9                  # ͤ
        bl      Factor                  # 
        srw     r0, r3, r9              # 򱦹 SHR (/2)
        b       e_next
    e_exp9:
    e_exit:
        lwz     r5, 0(r1)
        addi    r1, r1, 4               # restore r1
        mtlr    r5                      # restore lr
        lswi    r3, r1, 28              # pop r3-r9
        addi    r1, r1, 28              # restore r1
        blr

#-------------------------------------------------------------------------
# UNIX֤ޥñ̤֤
#-------------------------------------------------------------------------
GetTime:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        LWI     r3, TV
        mr      r5, r3
        addi    r4, r3, 8               # TZ
        li      r0, sys_gettimeofday
        sc
        lwz     r9, 0(r5)               # sec
        lwz     r0, 4(r5)               # usec
        SETVAR  r0, '%'                 # ; usec ¸
        bl      GetChar
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ޥñ̤Υ꡼ _=n
#-------------------------------------------------------------------------
Com_USleep:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        li      r3, 0
        LWI     r7, TV                  # 5
        stw     r3, 0(r7)               # sec  0
        stw     r0, 4(r7)               # usec
        mr      r4, r3
        mr      r5, r3
        mr      r6, r3
        li      r0, sys_select
        sc
        bl      CheckError
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿλ, r9 ֤ͤ
# ѿȤr13(¸)
# r0 Ͼ̤Factor¸
#-------------------------------------------------------------------------
Variable:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        stwu    r13, -4(r1)             # push r13
        bl      SkipAlpha               # ѿ̾ r9
        slwi    r6, r9, 2
        add     r13, r17, r6            # ѿΥɥ쥹
        cmpwi   r10, '('
        beq     v_array1                # 1Х
        cmpwi   r10, '{'
        beq     v_array2                # 2Х
        cmpwi   r10, '['
        beq     v_array4                # 4Х
        lwz     r9, 0(r13)               # ñѿ
        b       v_exit

    v_array1:
        bl      Exp                     # 1Х
        lwz     r13, 0(r13)
        bl      RangeCheck              # ϰϥå
        bso     v_range_err             # ϰϳ򥢥
        lbzx    r9, r13, r0
        bl      GetChar                 # skip )
        b       v_exit

    v_array2:
        bl      Exp                     # 2Х
        lwz     r13, 0(r13)
        bl      RangeCheck              # ϰϥå
        bso     v_range_err             # ϰϳ򥢥
        slwi    r0, r0, 1
        lhzx    r9, r13, r0
        bl      GetChar                 # skip }
        b       v_exit

    v_array4:
        bl      Exp                     # 4Х
        lwz     r13, 0(r13)
        bl      RangeCheck              # ϰϥå
        bso     v_range_err             # ϰϳ򥢥
        slwi    r6, r0, 2
        lwzx    r9, r13, r6
        bl      GetChar                 # skip )
        b       v_exit

    v_range_err:
        bl      RangeError
    v_exit:
        lwz     r13, 0(r1)              # pop r13
        lwzu    r4, 4(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿ
# r9 ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
#-------------------------------------------------------------------------
Factor:
        subi    r1, r1, 24
        stswi   r3, r1, 24              # push r3-r8
        mflr    r3                      # save lr
        stwu    r3, -4(r1)              # push lr
        stwu    r0, -4(r1)              # push r0
        bl      GetChar
        bl      IsNum
        bso     f_bracket
        bl      Decimal                 # 10
        mr      r9, r0
        b       f_exit       #

    f_bracket:
        cmpwi   r10, '('
        bne     f_yen
        bl      Exp                     # å
        mr      r9, r0                  # ͤ r9
        bl      GetChar                 # skip )
        b       f_exit       #

    f_yen:
        cmpwi   r10, '\\
        bne     f_rand
        lbz     r10, 0(r12)             # PeekChar
        cmpwi   r10, '\\                # '\\'
        beq     f_env

        bl      Exp                     # ֹ򼨤
        LWI     r4, argc_vtl            # vtlѤΰθĿ
        lwz     r4, 0(r4)
        cmpw    r0, r4                  # ֹȰο
        blt     2f                      # ֹ < ο
        LWI     r4, argvp               # not found
        lwz     r4, 0(r4)               # argvp0
        lwz     r9, 0(r4)               # argvp0(0)
        subi    r9, r9, 1
    1:  lbzu    r4, 1(r9)               # 0õ
        cmpwi   r4, 0
        bne     1b
        b       3f
    2:  LWI     r4, argp_vtl            # found
        lwz     r4, 0(r4)
        slwi    r6, r0, 2
        lwzx    r9, r4, r6              # ʸƬɥ쥹
    3:  b       f_exit       #

    f_env:
        bl      GetChar                 # skip '\'
        bl      Exp
        LWI     r4, envp
        lwz     r4, 0(r4)               # &env[0]
        li      r3, 0                   # Ķѿ򥫥
    4:  slwi    r5, r3, 2
        lwzx    r6, r4, r5
        cmpwi   r6, 0                   # ڤΥ̥ݥ
        beq     5f
        addi    r3, r3, 1
        b       4b
    5:
        cmpw    r0, r3
        bge     6f                      # ֹ椬
        slwi    r5, r0, 2
        lwzx    r9, r4, r5              # ʸƬɥ쥹
        b       f_exit       #
    6:
        slwi    r5, r3, 2
        add     r9, r4, r5              # 0ؤΥݥ(ʸ)
        b       f_exit       #

    f_rand:
        cmpwi   r10, '`'
        bne     f_hex
        bl      genrand                 # ɤ߽Ф
        mr      r9, r0
        bl      GetChar
        b       f_exit       #

    f_hex:
        cmpwi   r10, '$'
        bne     f_time
        bl      Hex                     # 16ʿޤ1ʸ
        b       f_exit       #

    f_time:
        cmpwi   r10, '_'
        bne     f_num
        bl      GetTime                 # ֤֤
        b       f_exit       #

    f_num:
        cmpwi   r10, '?'
        bne     f_char
        bl      NumInput                # 
        b       f_exit       #

    f_char:
        cmpwi   r10, 0x27
        bne     f_neg
        bl      CharConst               # ʸ
        b       f_exit       #

    f_neg:
        cmpwi   r10, '-'
        bne     f_abs
        bl      Factor                  # 
        neg     r9, r9
        b       f_exit       #

    f_abs:
        cmpwi   r10, '+'
        bne     f_realkey
        bl      Factor                  # ѿ
        and.    r9, r9, r9
        bge     f_exit
        neg     r9, r9
        b       f_exit       #

    f_realkey:
        cmpwi   r10, '@'
        bne     f_winsize
        bl      RealKey                 # ꥢ륿७
        mr      r9, r0
        bl      GetChar
        b       f_exit       #

    f_winsize:
        cmpwi   r10, '.'
        bne     f_pop
        bl      WinSize                 # ɥ
        mr      r9, r0
        bl      GetChar
        b       f_exit       #

    f_pop:
        cmpwi   r10, ';'
        bne     f_label
        lwz     r4, -16(r17)            # VSTACK
        subic.  r4, r4, 1
        bge     0f
        li      r4, 2
        stb     r4, -19(r17)            # ѿå顼
    0:  blt     1f
        slwi    r6, r4, 2
        add     r3, r17, r6
        addi    r3, r3, 1024            # r17+r4*4+1024
        lwz     r9, 0(r3)               # ѿå
        stw     r4, -16(r17)            # åݥ󥿹
    1:  bl      GetChar
        b       f_exit       #

    f_label:
.ifdef VTL_LABEL
        cmpwi   r10, '^'
        bne     f_var
        bl      LabelSearch             # ٥Υɥ쥹
        bns     2f
        li      r4, 3
        stb     r4, -19(r17)            # ٥륨顼
    2:  b       f_exit       #
.endif

    f_var:
        bl      Variable                # ѿ󻲾
    f_exit:
        lwz     r0, 0(r1)               # pop r0
        lwzu    r3, 4(r1)               # pop lr
        mtlr    r3                      # restore lr
        addi    r1, r1, 4               # restore r1
        lswi    r3, r1, 24              # pop r3-r8
        addi    r1, r1, 24              # restore r1
        blr                             # return

#-------------------------------------------------------------------------
# 󥽡뤫
#-------------------------------------------------------------------------
NumInput:
        mflr    r4
        stwu    r4, -4(r1)              # push lr

        mr      r18, r14                # EOL
        li      r3, MAXLINE             # 1 
        stwu    r12, -4(r1)             # push r12
        LWI     r4, input2              # ԥꥢ
        bl      READ_LINE3
        mr      r12, r4
        lbz     r10, 0(r12)             # 1ʸɤ
        addi    r12, r12, 1
        bl      Decimal
        lwz     r12, 0(r1)              # pop 12
        addi    r1, r1, 4               # restore r1
        mr      r9, r0
        mr      r14, r18                # EOL
        bl      GetChar

        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# 󥽡뤫 input2 ʸ
#-------------------------------------------------------------------------
StringInput:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        mr      r18, r14                # EOL
        li      r3, MAXLINE             # 1 
        LWI     r4, input2              # ԥꥢ
        bl      READ_LINE3
    2:  SETVAR  r0, '%                  # %
        mr      r14, r18                # EOL
        bl      GetChar
        mr      r9, r4
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ʸͤѴ
# r9 ˿֤ͤ
#-------------------------------------------------------------------------
CharConst:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        li      r9, 0
        li      r0, 4                   # ʸ4ХȤޤ
    1:
        bl      GetChar
        cmpwi   r10, 0x27               # '''
        beq     2f
        slwi    r6, r9, 8
        add     r9, r10, r6
        subic.  r0, r0, 1
        bne     1b
    2:
        bl      GetChar
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# 16ʸͤѴ
# r9 ˿֤ͤ
#-------------------------------------------------------------------------
Hex:
        lbz     r10, 0(r12)             # check $$
        cmpwi   r10, '$
        beq     StringInput

        mflr    r4
        stwu    r4, -4(r1)              # push lr
        li      r9, 0
        mr      r4, r9
    1:
        bl      GetChar                 # $ μʸ
        bl      IsNum
        bso     2f
        subi    r10, r10, '0'           # Ѵ
        b       4f
    2:
        cmpwi   r10, ' '                # ʳ
        beq     5f
        cmpwi   r10, 'A'
        blt     5f                      # 'A' 꾮ʤ
        cmpwi   r10, 'F'
        bgt     3f
        subi    r10, r10, 55            # -'A'+10 = -55
        b       4f
    3:
        cmpwi   r10, 'a'
        blt     5f
        cmpwi   r10, 'f'
        bgt     5f
        subi    r10, r10, 87            # -'a'+10 = -87
    4:
        slwi    r6, r9, 4
        add     r9, r10, r6
        addi    r4, r4, 1
        b       1b
    5:
        and.    r4, r4, r4
        beq     CharInput
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# 󥽡뤫 1 ʸ, EBX֤
#-------------------------------------------------------------------------
CharInput:
        bl      InChar
        mr      r9, r0
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ԤԽ
#  r0 ֹ
# r10   ʸ(GetChar֤)
# r11   ¹ԻƬ
# r12   ؤΥݥ(getcharǹ)
# r13   ѿΥɥ쥹
# r14   EOL ե饰
# r15   PutDecimalν񤭹Хåե
# r16   쥯ե̾(fork & exec)
# r17   ѿΰƬɥ쥹
# r18   r14 (NumInput, StringInput)
# r19   ̤
#-------------------------------------------------------------------------
LineEdit:
        bl      LineSearch              # ϺѤ߹ֹõ
        bns     4f                      # ĤʤΤǽλ
        LWI     r15, input              # ϥХåե
        lwz     r3, 4(r11)
        addi    r11, r11, 7
        bl      PutDecimal              # ֹ񤭹
        li      r3, ' '
        stb     r3, 0(r15)
    2:
        lbzu    r3, 1(r11)              # ԤϥХåե˥ԡ
        stbu    r3, 1(r15)
        cmpwi   r3, 0
        bne     2b                      # ?
    3:
        bl      DispPrompt
        li      r3, MAXLINE             # 1 
        LWI     r4, input
        bl      READ_LINE2              # ѹ
        mr      r12, r4
    4:
        li      r14, 0                  # EOL=no, ϺѤ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

#-------------------------------------------------------------------------
# ListMore
#   r0 ɽϹֹ
#-------------------------------------------------------------------------
ListMore:
        bl      LineSearch              # ɽϹԤ򸡺
        bl      GetChar                 # skip '+'
        bl      Decimal                 # ɽԿ
        bns     0f
        li      r0, 20                  # ɽԿ̵20
    0:  mtctr   r0
        mr      r3, r11
    1:  lwz     r9, 0(r3)               # ԤޤǤΥեå
        and.    r9, r9, r9
        blt     List_all                # ɺǽ?
        lwz     r7, 4(r3)               # ֹ
        add     r3, r3, r9              # Ƭ
        bdnz    1b

        b       List_loop

#-------------------------------------------------------------------------
# List
#  r0 ɽϹֹ
#  r11 ɽƬɥ쥹(˲)
#-------------------------------------------------------------------------
List:
        and.    r0, r0, r0              # ֹ0ʤɽ
        bne     1f                      # ʬɽ
        GETVAR  r11, '=                 # ץƬ
        b       List_all                # ٤ɽ

    1:  bl      LineSearch              # ɽϹԤ򸡺
        bl      GetChar                 # ͤǤ -
        bl      Decimal                 # ϰϺǽ
        bso     List_all
        mr      r7, r0                  # λֹ
        b       List_loop

List_all:
        li      r7, -1                  # ǽޤɽ()
List_loop:
        lwz     r5, 0(r11)              # ԤޤǤΥեå
        and.    r5, r5, r5
        blt     6f                      # ɺǽ?
        lwz     r3, 4(r11)              # ֹ
        cmplw   r3, r7
        bgt     6f
        bl      PrintLeft               # ֹɽ
        li      r3, ' '
        bl      OutChar
        li      r9, 8
    4:
        lbzx    r3, r11, r9             # ʬɽ
        cmpwi   r3, 0
        beq     5f                      # 
        bl      OutChar
        addi    r9, r9, 1               # 1ʸ
        b       4b

    5:  bl      NewLine
        add     r11, r11, r5
        b       List_loop               # Խ

    6:
        li      r14, 1                  # ˹ EOL=yes
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

.ifdef DEBUG

#-------------------------------------------------------------------------
# ǥХåѥץԥꥹ <xxxx> 1#
#-------------------------------------------------------------------------
DebugList:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        GETVAR  r7, '=                  # ץƬ
        mr      r3, r7
        bl      PrintHex8               # ץƬɽ
        li      r3, ' '
        bl      OutChar
        GETVAR  r3, '&                  # ҡƬ
        bl      PrintHex8               # ҡƬɽ
        sub     r5, r3, r7              # ץΰ襵
        li      r3, ' '
        bl      OutChar
        mr      r3, r5
        bl      PrintLeft
        bl      NewLine
        li      r3, -1                  # ǽޤɽ()
    1:
        mr      r3, r7
        bl      PrintHex8               # Ƭɥ쥹
        lwz     r5, 0(r7)               # ԤޤǤΥեå
        li      r3, ' '
        bl      OutChar
        mr      r3, r5
        bl      PrintHex8               # եåȤ16ɽ
        li      r4, 4                   # 4屦
        bl      PrintRight              # եåȤ10ɽ
        li      r3, ' '
        bl      OutChar
        and.    r5, r5, r5
        ble     4f                      # ɺǽ?

        lwz     r3, 4(r7)               # ֹ
        cmpwi   r3, -1
        blt     4f
        bl      PrintLeft               # ֹɽ
        li      r3, ' '
        bl      OutChar
        li      r9, 8
    2:
        lbzx    r3, r7, r9              # ʬɽ
        cmpwi   r3, 0
        beq     3f                      # 
        bl      OutChar
        addi    r9, r9, 1               # 1ʸ
        b       2b
    3:  bl      NewLine
        add     r7, r7, r5
        b       1b                      # Խ

    4:  bl      NewLine
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

call_DebugList:
        bl      DebugList
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

#-------------------------------------------------------------------------
# ǥХåѿꥹ <xxxx> 1$
#-------------------------------------------------------------------------
VarList:
        mflr    r4
        stwu    r4, -4(r1)              # push lr

        li      r5, 0x21
    1:  mr      r3, r5
        bl      OutChar
        li      r3, ' '
        bl      OutChar
        slwi    r6, r5, 2
        lwzx    r3, r17, r6             # ѿ
        bl      PrintHex8
        li      r4, 12                  # ɽ
        bl      PrintRight
        bl      NewLine
        addi    r5, r5, 1
        cmpwi   r5, 0x7F
        blt     1b
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

call_VarList:
        bl      VarList
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

#-------------------------------------------------------------------------
# ǥХåѥץꥹ <xxxx> 1%
#-------------------------------------------------------------------------
DumpList:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        GETVAR  r5, '=                  # ץƬ
        li      r4, 0xfffffff0
        and     r5, r5, r4              # 16byteϤ
        li      r7, 8
        subi    r5, r5, 1               # for update adressing
    1:  addi    r3, r5, 1
        bl      PrintHex8               # Ƭɥ쥹ɽ
        li      r3, ' '
        bl      OutChar
        li      r3, ':'
        bl      OutChar
        li      r3, 16
        mtctr   r3
    2:
        li      r3, ' '
        bl      OutChar
        lbzu    r3, 1(r5)               # 1Хɽ
        bl      PrintHex2
        bdnz    2b
        bl      NewLine
        subic.  r7, r7, 1
        bne     1b                      # Խ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

call_DumpList:
        bl      DumpList
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

#-------------------------------------------------------------------------
# ǥХåѥ٥ꥹ <xxxx> 1&
#-------------------------------------------------------------------------
LabelList:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        LWI     r5, LabelTable          # ٥ơ֥Ƭ
        LWI     r4, TablePointer
        lwz     r3, 0(r4)               # ơ֥ǽϿ
    1:
        cmplw   r5, r3
        bge     2f
        lwz     r3, 12(r5)
        bl      PrintHex8
        li      r3, ' '
        bl      OutChar
        mr      r3, r5
        bl      OutAsciiZ
        bl      NewLine
        addi    r5, r5, 16
        b       1b

call_LabelList:
        bl      LabelList
     2: lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn
.endif

#-------------------------------------------------------------------------
#  Խ⡼
#  Mainloopcall
#       1) ֹ 0 ʤꥹ
#       2) ԤֹΤߤξϹԺ
#       3) ֹľ夬 - ʤֹʬꥹ
#       4) ֹľ夬 + ʤԿʬꥹ
#       5) ֹľ夬 ! ʤԽ
#       6) ƱֹιԤ¸ߤؤ
#       7) Ʊֹ椬ʤ
#-------------------------------------------------------------------------
EditMode:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      Decimal                 # ֹ
        and.    r0, r0, r0              # ֹ
        beq     List                    # ֹ 0 ʤꥹ
        cmpwi   r10, 0                  # ֹΤߤ
        bne     1f
        bl      LineDelete              # Ժ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

    1:  cmpwi   r10, '-
        beq     List                    # ʬꥹ
        cmpwi   r10, '+
        beq     ListMore                # ʬꥹ 20
.ifdef DEBUG
        cmpwi   r10, '#
        beq     call_DebugList          # ǥХåѹԥꥹ(#)
        cmpwi   r10, '$
        beq     call_VarList            # ǥХåѿꥹ($)
        cmpwi   r10, '%
        beq     call_DumpList           # ǥХåѥץꥹ(%)
        cmpwi   r10, '&
        beq     call_LabelList          # ǥХåѥ٥ꥹ(&)
.endif
        cmpwi   r10, '!'
        beq     LineEdit                # Խ
        bl      LineSearch              # ϺѤ߹ֹõ
        bns     LineInsert              # פԤʤ
        bl      LineDelete              # ִ(Ժ+)

#-------------------------------------------------------------------------
# 
# r0 ֹ
# r11 
#-------------------------------------------------------------------------
LineInsert:
        li      r5, 0                   # ԤΥ׻
    1:  lbzx    r4, r12, r5             # r12:ϥХåեƬ
        cmpwi   r4, 0                   # ?
        addi    r5, r5, 1               # ʸ
        bne     1b

        addi    r5, r5, 12              # 12=4+4+1+3
        li      r3, -4
        and     r5, r5, r3              # 4Хȶ(0xfffffffc)
        GETVAR  r3, '&                  # ҡƬ()
        mr      r4, r3                  # ΥҡƬ
        add     r3, r3, r5              # ҡƬ׻
        SETVAR  r3, '&                  # ҡƬ
        sub     r6, r4, r11             # ưХȿ
        mtctr   r6

    2:  # ְʹߤž old &-1  new &-1 ؤΥԡ
        lbzu    r6, -1(r4)              # ư
        stbu    r6, -1(r3)
        bdnz    2b

        stw     r5, 0(r11)              # ԤؤΥեå
        stw     r0, 4(r11)              # ֹ
        addi    r11, r11, 8             # 񤭹ֹ߰

    3:  # ϥХåեإԡ
        lbz     r4, 0(r12)              # r12:ϥХåե
        stb     r4, 0(r11)              # r11:
        addi    r12, r12, 1
        addi    r11, r11, 1
        cmpwi   r4, 0                   # ?
        bne     3b
        li      r14, 1                  # ˹ EOL=yes
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # Mainloopreturn

#-------------------------------------------------------------------------
# Ԥκ
# r0 ˸ֹ
#-------------------------------------------------------------------------
LineDelete:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      LineSearch              # ϺѤ߹ֹõ
        bns     2f                      # פԤʤнλ
        mr      r4, r11                 # Ƭ
        lwz     r5, 0(r11)              # ԥեåȼ
        add     r5, r11, r5             # Ƭּ
        GETVAR  r3, '&                  # ҡƬ
        sub     r3, r3, r5              # r3:ưХȿ
        mtctr   r3
    1:
        lbz     r3, 0(r5)               # r10ХȰư
        stb     r3, 0(r4)
        addi    r5, r5, 1
        addi    r4, r4, 1
        bdnz    1b
        SETVAR  r4, '&                  # r5 ҡƬ
    2:
        li      r14, 1                  # ˹ EOL=yes

        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # return

#-------------------------------------------------------------------------
# ϺѤ߹ֹõ
# r0 ˸ֹ桢r3, r4 ˲
# ׹Ƭޤ԰פξˤϼ礭ֹƬ֤r11
# Ʊֹ椬Хޥ꡼Сեå
#-------------------------------------------------------------------------
LineSearch:
        GETVAR  r11, '=                 # ץƬ
LineSearch_nextline:
    1:  lwz     r4, 0(r11)              # ʤ鸡λ
        and.    r4, r4, r4              # offset > 0
        blt     3f                      # offset = -1 then exit
        lwz     r3, 4(r11)              # ֹ
        cmplw   r0, r3                  # ̵ǹֹ
        beq     2f                      # r0 = ܹr3
        blt     3f                      # r0 < ܹr3
        add     r11, r11, r4            # Ƭ (r11=r11+offset)
        b       1b
    2:  creqv   3, 8, 8                 # cr0[so]=1
        blr                             # return
    3:  crxor   3, 8, 8                 # cr0[so]=0
        blr                             # return

#-------------------------------------------------------------------------
# 10ʸѴ
# r0 ˿֤ͤ롢ͤʤ饭꡼å
# 1 ʸɤ(r10)ǸƤФ졢1 ʸɤ(r10)֤
#-------------------------------------------------------------------------
Decimal:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        li      r4, 0                   # 
        li      r0, 0
        li      r5, 10
        cmpwi   r10, '+
        beq     1f
        cmpwi   r10, '-
        bne     2f                      # Num
        li      r4, 1                   # 
    1:
        bl      GetDigit
        bso     4f                      # Ǥʤ֤
        b       3f
    2:
        bl      IsNum
        bso     4f                      # Ǥʤ
        subi    r10, r10, '0            # ͤѴ

    3:
        mullw   r3, r0, r5              # r3=r3*10+r10
        add     r0, r3, r10
        bl      GetDigit
        bns     3b
        and.    r4, r4, r4              # 餫
        beq     4f
        neg     r0, r0                  # ˤ
    4:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr                             # return

#-------------------------------------------------------------------------
# ̵10ʿʸ r15 μ˽񤭹
# r3 : 
#-------------------------------------------------------------------------
PutDecimal:
        subi    r1, r1, 24
        stswi   r3, r1, 24              # push r3-r8
        li      r5, 0                   # counter
    1:  mr      r6, r3
        li      r7, 10                  # r7 = 10
        divwu   r3, r3, r7              # r3 = r3/10
        mullw   r8, r3, r7              # r8 = quotient * 10
        subf    r8, r8, r6              # r8 = mod(r3/10)
        addi    r5, r5, 1               # counter++
        stwu    r8, -4(r1)              # least digit (reminder)
        cmpwi   r3, 0
        bne     1b                      # done ?

        mtctr   r5
    2:  lwz     r3, 0(r1)               # pop  most digit
        addi    r1, r1, 4               # restore r1
        addi    r3, r3, '0'             # ASCII
        stb     r3, 0(r15)              # output a digit
        addi    r15, r15, 1
        bdnz    2b

        lswi    r3, r1, 24              # pop r3-r8
        addi    r1, r1, 24              # restore r1
        blr                             # return

#---------------------------------------------------------------------
# r10 ʸɤΥå
# ʤѴ r10 ֤. ʤ饵ޥꥪХեå
#---------------------------------------------------------------------

IsNum:  cmpwi   cr2, r10, '0'           # r10 < '0'  cr2[lt]=1
        cmpwi   cr3, r10, '9'           # r10 > '9'  cr3[gt]=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

GetDigit:
        mflr    r3                      # save lr
        stwu    r3, -4(r1)              # push lr
        bl      GetChar                 # 0 - 9
        bl      IsNum
        bso     1f
        subi    r10, r10, '0'           # Ѵ
    1:
        lwz     r3, 0(r1)               # pop lr
        mtlr    r3                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

IsAlpha:
        stwu    r3, -4(r1)              # push r3
        mflr    r3                      # save lr
        bl      IsAlpha1                # ʸ?
        bns     1f                      # yes
        bl      IsAlpha2                # Ѿʸ?
    1:  mtlr    r3                      # restore lr
        lwz     r3, 0(r1)               # pop r3
        addi    r1, r1, 4               # restore r1
        blr

IsAlpha1:
        cmpwi   cr2, r10, 'A            # ʸ(A-Z)?
        cmpwi   cr3, r10, 'Z            # if r10>'Z' gt=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

IsAlpha2:
        cmpwi   cr2, r10, 'a            # ʸ(A-Z)?
        cmpwi   cr3, r10, 'z            # if r10>'z' gt=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

IsAlphaNum:
        mflr    r3                      # save lr
        stwu    r3, -4(r1)              # push lr
        bl      IsAlpha                 # ʸ?
        bns     1f                      # yes
        bl      IsNum                   # ?
    1:
        lwz     r3, 0(r1)               # pop lr
        mtlr    r3                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# եɤ߹
#-------------------------------------------------------------------------
READ_FILE:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        stwu    r6, -4(r1)              # push r6
        li      r7,  0                  # r7=0
        LWI     r6, input               # ϥХåեɥ쥹
    1:
        lwz     r3, -8(r17)             # FileDesc
        mr      r4, r6
        li      r5, 1                   # ɤߤߥХȿ
        li      r0, sys_read            # ե뤫ɤߤ
        sc
        and.    r3, r3, r3
        beq     2f                      # EOF ?

        lbz     r0, 0(r6)
        cmpwi   r0, 10                  # LineFeed ?
        beq     3f
        addi    r6, r6, 1               # input++
        b       1b
    2:
        lwz     r3, -8(r17)             # FileDesc
        bl      fclose                  # File Close
        stb     r7, -4(r17)             # Read from console (0)
        bl      LoadCode                # ưեͭ
        b       4f
    3:  mr      r14, r7                 # EOL=no
    4:  stb     r7, 0(r6)
        LWI     r12, input
        lwz     r6, 0(r1)               # pop lr
        lwz     r4, 4(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 8               # restore r1
        blr

#-------------------------------------------------------------------------
# ͽ ?
#-------------------------------------------------------------------------
Com_OutNum:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # get next
        cmpwi   r10, '='
        bne     1f
        bl      Exp                     # PrintLeft
        mr      r3, r0
        bl      PrintLeft
        b       on_exit

    1:
        cmpwi   r10, '*'                # ̵10
        beq     on_unsigned
        cmpwi   r10, '$'                # ?$ 162
        beq     on_hex2
        cmpwi   r10, '#'                # ?# 164
        beq     on_hex4
        cmpwi   r10, '?'                # ?? 168
        beq     on_hex8
        mr      r5, r10
        bl      Exp
        andi.   r4, r0, 0xff            # ɽ(MAX255)
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        mr      r3, r0
        cmpwi   r5, '{'                 # ?{ 8ʿ
        beq     on_oct
        cmpwi   r5, '!'                 # ?! 2nӥå
        beq     on_bin
        cmpwi   r5, '('                 # ?( print right
        beq     on_dec_right
        cmpwi   r5, '['                 # ?0( print right
        beq     on_dec_right0
        b       pop_and_Error           # å SyntaxError

    on_unsigned:
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        mr      r3, r0
        bl      PrintLeftU
        b       on_exit
    on_hex2:
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        mr      r3, r0
        bl      PrintHex2
        b       on_exit
    on_hex4:
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        mr      r3, r0
        bl      PrintHex4
        b       on_exit
    on_hex8:
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        mr      r3, r0
        bl      PrintHex8
        b       on_exit
    on_oct:
        bl      PrintOctal
        b       on_exit
    on_bin:
        bl      PrintBinary
        b       on_exit
    on_dec_right:
        bl      PrintRight
        b       on_exit
    on_dec_right0:
        bl      PrintRight0
    on_exit:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ʸ $
#-------------------------------------------------------------------------
Com_OutChar:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # get next
        cmpwi   r10, '='
        beq     1f
        cmpwi   r10, '$'                # $$ 2byte
        beq     2f
        cmpwi   r10, '#'                # $# 4byte
        beq     4f
        cmpwi   r10, '*'                # $*=StrPtr
        beq     6f
        b       7f

    1:  bl      Exp                     # 1Хʸ
        mr      r3, r0
        b       3f

    2:  bl      SkipEqualExp            # 2Хʸ
        andi.   r4, r0, 0x00ff
        andi.   r3, r0, 0xff00
        srwi    r3, r3, 8               # ̥ХȤ
        bl      OutChar
        mr      r3, r4
    3:  bl      OutChar
        b       7f

    4:  bl      SkipEqualExp            # 4Хʸ
        mr      r4, r0
        li      r3, 4
        mtctr   r3
    5:
        rlwinm  r4, r4, 8, 0, 31        # 8ӥåȤФ
        andi.   r3, r4, 0xff
        bl      OutChar
        bdnz    5b
        b       7f

    6:  bl      SkipEqualExp
        mr      r3, r0
        bl      OutAsciiZ
    7:  lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
#  .=n
#-------------------------------------------------------------------------
Com_Space:
        mflr    r4
        bl      SkipEqualExp            # 1ʸɤФ ɾ
        li      r3, ' '
    1:  bl      OutChar
        subic.  r0, r0, 1
        bne     1b
        mtlr    r4                      # restore lr
        blr

#-------------------------------------------------------------------------
# Խ /
#-------------------------------------------------------------------------
Com_NewLine:
        mflr    r4
        bl      NewLine
        mtlr    r4                      # restore lr
        blr

#-------------------------------------------------------------------------
# ʸ "
#-------------------------------------------------------------------------
Com_String:
        mflr    r5
        li      r4, 0
        mr      r3, r12                 # ʸƬɥ쥹
    1:  bl      GetChar
        cmpwi   r10, '"'
        beq     2f
        cmpwi   r14, 1                  # EOL=yes ?
        beq     2f
        addi    r4, r4, 1
        b       1b
    2:
        bl      OutString               # r3:address, r4:length
        mtlr    r5                      # restore lr
        blr

#-------------------------------------------------------------------------
# GOTO #
#-------------------------------------------------------------------------
Com_GO:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar
        cmpwi   r10, '!'
        beq     2f                      # #! ϥȡ԰ư
.ifdef VTL_LABEL
        bl      ClearLabel
.endif
        bl      SkipEqualExp2           # = å ɾ
Com_GO_go:
        lbz     r9, -3(r17)             # ExecMode=Direct ?
        cmpwi   r9, 0
        beq     4f                      # Directʤ٥

.ifdef VTL_LABEL
        GETVAR  r5, '^'                 # ƥѿ^פΥå
        and.    r5, r5, r5              # ǥ٥뻲Ȥ뤫?
        beq     1f                      # ̵Ϲֹ
        mr      r11, r0                 # r11 ԤƬɥ쥹
        li      r0, 0                   # ƥѿ^ץꥢ
        SETVAR  r0, '^                  # ٥̵
        b       6f                      # check
.endif

    1: # ֹ
        and.    r0, r0, r0              # #=0 ʤ鼡
        bne     3f                      # ֹ˥
    2: # nextline
        li      r14, 1                  # Ԥ˰ư  EOL=yes
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    3: # ֹ򸡺
        lwz     r9, 4(r11)              # ߤιԤȹֹ
        cmpw    r0, r9
        blt     5f                      # Ƭ鸡
        bl      LineSearch_nextline     # ߹Ԥ鸡
        b       6f                      # check

    4: # label
.ifdef VTL_LABEL
        bl      LabelScan               # ٥ơ֥
.endif

    5: # top:
        bl      LineSearch              # r11 ԤƬ
    6: # check:
        lwz     r0, 0(r11)              # å
        addic.  r0, r0, 1
        beq     7f                      # stop
        li      r0, 1
        stb     r0, -3(r17)             # ExecMode=Memory
        bl      SetLineNo               # ֹ # 
        addi    r12, r11, 8             # Ƭ
        li      r14, 0                  # EOL=no
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr
    7: # stop:
        bl      CheckCGI                # CGI⡼ɤʤ齪λ
        bl      WarmInit1               # ϥǥХѹʤ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

.ifdef VTL_LABEL
#-------------------------------------------------------------------------
# ǤΥ٥뻲ȷ̤򥯥ꥢ
#-------------------------------------------------------------------------
ClearLabel:
        li      r0, 0                   # ƥѿ^ץꥢ
        SETVAR  r0, '^                  # ٥̵
        blr

#-------------------------------------------------------------------------
# ɤ򥹥󤷤ƥ٥ȥ٥μιԥɥ쥹ơ֥Ͽ
# ٥ơ֥16Хȡȥ4096(64KB)
# 12ХȤASCIIZ(11ХȤΥ٥ʸ) + 4Х(Ƭɥ쥹)
# r10,r11 
#-------------------------------------------------------------------------
LabelScan:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        GETVAR  r11, '='                # Ƭɥ쥹
        lwz     r3, 0(r11)              # ʤ齪λ
        addic.  r3, r3, 1
        beq     8f                      # ʤ齪λ
    1:
        LWI     r8, LabelTable          # ٥ơ֥Ƭ
        LWI     r7, TablePointer
        stw     r8, 0(r7)               # ϿֳǼ

    2:
        li      r5, 8                   # ƥƬ
    3:                                  # 򥹥å
        lbzx    r3, r11, r5             # 1ʸ
        cmpwi   r3, 0
        beq     7f                      # ʤ鼡
        cmpwi   r3, ' '                 # ɤФ
        bne     4f                      # ٥Ͽ
        addi    r5, r5, 1
        b       3b

    4: # nextch
        cmpwi   r3, '^'                 # ٥?
        bne     7f                      # ٥Ǥʤ
        # ٥Ͽ
        addi    r5, r5, 1               # ٥ʸƬ
        li      r4, 0                   # ٥Ĺ
    5:
        lbzx    r3, r11, r5             # 1ʸ
        cmpwi   r3, 0
        beq     6f                      # 
        cmpwi   r3, ' '                 # ٥ζڤ϶
        beq     6f                      # ٥ʸ
        cmpwi   r4, 11                  # 11ʸޤ
        beq     6f                      # ʸ
        stbx    r3, r8, r4              # 1ʸϿ
        addi    r5, r5, 1
        addi    r4, r4, 1
        b       5b                      # ʸ

    6: # registerd
        li      r3, 0
        stbx    r3, r8, r4              # ٥ʸ
        lwz     r3, 0(r11)              # ԥեå
        add     r3, r11, r3             # r3˼Ƭ
        stw     r3, 12(r8)              # ɥ쥹Ͽ
        addi    r8, r8, 16
        mr      r11, r3
        stw     r8, 0(r7)               # Ͽ(TablePointer)

    7:                                  # Խ
        lwz     r3, 0(r11)              # ԥեå
        add     r11, r11, r3            # r3˼Ƭ
        lwz     r3, 0(r11)              # ԥեå
        addic.   r3, r3, 1
        beq     8f                      # λ
        cmpw    r8, r0                  # ơ֥ǽ
        beq     8f                      # λ
        b       2b                      # Ԥν򷫤֤

    8: # finish:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ơ֥뤫٥μιԥɥ쥹
# ٥μιԤƬɥ쥹 r9 ȡ^פꡢr10˼ʸ
# ֤롣Factor r12 ^μꤷƸƤФ
# եȤƻȤ r9 ֤
# r12 ϥ٥θ(ĹɤФ)ꤵ
# r3-r9 ˲
#-------------------------------------------------------------------------
LabelSearch:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        LWI     r8, LabelTable          # ٥ơ֥Ƭ
        LWI     r7, TablePointer
        lwz     r9, 0(r7)               # ơ֥ǽϿ

    1:
        li      r4, 0                   # ٥Ĺ
    2:
        lbzx    r10, r12, r4            # 
        lbzx    r3, r8, r4              # ơ֥
        and.    r3, r3, r3              # ơ֥ʸκǸ?
        bne     3f                      # Ӥ³
        bl      IsAlphaNum
        bso     4f                      # r10=space, r3=0

    3:  # ۤʤ
        cmpw    r10, r3                 # 
        bne     5f                      # פʤϼΥ٥
        addi    r4, r4, 1               # פ鼡ʸ
        cmpwi   r4, 11                  # ĹΥå
        bne     2b                      # ʸ
        bl      Skip_excess             # Ĺ᤮٥ϸɤФ

    4:  # found
        lwz     r9, 12(r8)              # ơ֥뤫饢ɥ쥹
        SETVAR  r9, '^'                 # ѿ^פ˥٥μƬ
        add     r12, r12, r4
        bl      GetChar
        crxor   3, 8, 8                 # cr0[so]=0: ĤSOꥢ
        b       7f                      # return

    5:  # next
        addi    r8, r8, 16
        cmpw    r8, r9                  # ơ֥κǽȥ
        beq     6f                      # Ĥʤ
        cmpw    r8, r7                  # ơ֥ΰǽ?
        beq     6f                      #
        b       1b                      # Υơ֥륨ȥ

    6:  # not found:
        li      r4, 0
        bl      Skip_excess             # ٥򤫹ޤФ
        li      r9, 0
        creqv   3, 8, 8                 # cr0[so]=1: ʤSOå
    7:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

Skip_excess:
        mflr    r5
        stwu    r5, -4(r1)              # push lr
    1:  lbzx    r10, r12, r4            # Ĺ᤮٥ϥå
        bl      IsAlphaNum
        bso     2f                      # ѿʳ
        addi    r4, r4, 1               # ɤ߹ֹ߰
        b       1b
    2:  lwz     r5, 0(r1)               # pop lr
        mtlr    r5                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

.endif

#-------------------------------------------------------------------------
# = Ƭɥ쥹
#-------------------------------------------------------------------------
Com_Top:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        mr      r3, r0
        bl      RangeCheck              # ',' <= '=' < '*'
        bso     4f                      # ϰϳ顼
        SETVAR  r3, '='                 # ͤ=(Ƭ)
        GETVAR  r4, '*'                 # r4=*()
    1: # nextline:                      # 
        lwz     r0, 0(r3)               # ԤؤΥեå
        addic.  r9, r0, 1               # Ƭ -1 ?
        beq     2f                      # yes
        and.    r0, r0, r0
        ble     3f                      # ԤؤΥեå <= 0 
        lwz     r9, 4(r3)               # ֹ > 0
        and.    r9, r9, r9
        ble     3f                      # ֹ <= 0 
        add     r3, r3, r0              # Ƭɥ쥹
        cmpw    r4, r3                  # Ƭ > 
        ble     3f                      #
        b       1b                      # Խ
    2: # found:
        mr      r4, r0                  # ȯ
        b       Com_NEW_set_end         # & 
    3: # endmark_err:
        LWI     r3, EndMark_msg         # ץ̤
        bl      OutAsciiZ
        bl      WarmInit                #
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    4: # range_err
        bl      RangeError
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ޡȶƬ &
#   = (ΰƬ)ͤǻ, Хɥ쥹ꤵ
#-------------------------------------------------------------------------
Com_NEW:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        GETVAR  r4, '='                 # &==+4 (Ƭ+4)
        li      r0, -1                  # ޡ(-1)
        stw     r0, 0(r4)               # ޡ
Com_NEW_set_end:
        addi    r4, r4, 4               # μ
        SETVAR  r4, '&'                 # Ƭ
        bl      WarmInit1               # ϥǥХѹʤ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# BRK *
#    ǽ֤, brk
#-------------------------------------------------------------------------
Com_BRK:
.ifdef MACOSX
        b       pop_and_Error
.else
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        mr      r3, r0
        li      r0, sys_brk             # 
        sc
        SETVAR  r3, '*'                 # ҡƬ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr
.endif

#-------------------------------------------------------------------------
# RANDOM '
#-------------------------------------------------------------------------
Com_RANDOM:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        SETVAR  r0, '`'                 # 
        mr      r3, r0
        bl      sgenrand
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ϰϥåե饰 [
#-------------------------------------------------------------------------
Com_RCheck:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        SETVAR  r0, '['                 # ϰϥå
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿޤϼ򥹥å¸
#-------------------------------------------------------------------------
Com_VarPush:
        mflr    r4
        stwu    r4, -4(r1)              # push lr

        lwz     r4, -16(r17)            # VSTACK
        li      r3, VSTACKMAX
        subi    r3, r3, 1               # r3 = VSTACKMAX - 1
    1: # next
        cmpw    r4, r3
        bgt     VarStackError_over
        bl      GetChar
        cmpwi   r10, '='                # +=
        bne     2f
        bl      Exp
        addi    r9, r17, 1024           # (r17+r4*4+1024)
        slwi    r6, r4, 2
        stwx    r0, r9, r6              # ѿå˼¸
        addi    r4, r4, 1
        b       3f
    2: # push2
        cmpwi   r10, ' '
        beq     3f
        cmpwi   r14, 1                  # EOL=yes?
        beq     3f
        slwi    r6, r10, 2
        lwzx    r0, r17, r6             # ѿͼ
        addi    r9, r17, 1024           # (r17+r4*4+1024)
        slwi    r6, r4, 2
        stwx    r0, r9, r6              # ѿå˼¸
        addi    r4, r4, 1
        b       1b                      # ѿ
    3: # exit
        stw     r4, -16(r17)            # åݥ󥿹

        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# ѿ򥹥å
#-------------------------------------------------------------------------
Com_VarPop:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lwz     r4, -16(r17)            # VSTACK
    1: # next:
        bl      GetChar
        cmpwi   r10, ' '
        beq     2f
        cmpwi   r14 , 1                 # EOL=yes?
        beq     2f
        subic.  r4, r4, 1
        blt     VarStackError_under
        addi    r9, r17, 1024           # (r17+r4*4+1024)
        slwi    r6, r4, 2
        lwzx    r0, r9, r6              # ѿå
        slwi    r6, r10, 2
        stwx    r0, r17, r6             # ѿ
        b       1b
    2: # exit:
        stw     r4, -16(r17)            # åݥ󥿹
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# եǼƬ r13
#-------------------------------------------------------------------------
Com_FileTop:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        mr      r13, r0
        bl      RangeCheck              # ϰϥå
        bso     1f                      # Com_FileEnd:1 ϰϳ򥢥
        SETVAR  r0, '{'                 # եǼƬ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# եǼǽ r13
#-------------------------------------------------------------------------
Com_FileEnd:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      SkipEqualExp            # = ɤФ ɾ
        mr      r13, r0
        bl      RangeCheck              # ϰϥå
        bso     1f                      # ϰϳ򥢥
        SETVAR  r0, '}'                 # եǼƬ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr
    1: # range_err
        bl      RangeError
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# CodeWrite <=
#-------------------------------------------------------------------------
Com_CdWrite:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetFileName
        bl      fwopen                  # open
        bso     5f                      # error
        stw     r3, -12(r17)            # FileDescW
        GETVAR  r7, '='                 # Ƭɥ쥹
    1: # loop
        LWI     r15, input2             # ꥢ()
        lwz     r4, 0(r7)               # ԤؤΥեå
        addic.  r4, r4, 1               # ɺǽ?
        beq     4f                      # ǽʤ齪λ
        lwz     r3, 4(r7)               # ֹ
        bl      PutDecimal              # r3ιֹr12˽񤭹
        li      r0, ' '                 # ڡ
        stb     r0, 0(r15)              # Write One Char
        addi    r15, r15, 1
        li      r4, 8
    2: # code:
        lbzx    r0, r7, r4              # ʬ񤭹
        cmpwi   r0, 0                   # ?
        beq     3f                      # fileϸ弡
        stb     r0, 0(r15)              # Write One Char
        addi    r15, r15, 1
        addi    r4, r4, 1
        b       2b

    3: # next:
        lwz     r4, 0(r7)               # ԥեå
        add     r7, r7, r4              # Ƭ
        li      r0, 10                  # LF
        stb     r0, 0(r15)              # Խ
        addi    r15, r15, 1
        li      r0, 0
        stb     r0, 0(r15)              # EOL

        LWI     r3, input2              # Хåեɥ쥹
        bl      StrLen                  # r3ʸĹr0֤
        mr      r5, r0                  # 񤭤ߥХȿ
        mr      r4, r3                  # Хåեɥ쥹
        lwz     r3, -12(r17)            # FileDescW
        li      r0, sys_write           # ƥॳ
        sc
        b       1b                      # Խ
    4: # exit:
        lwz     r3, -12(r17)            # FileDescW
        bl      fclose                  # ե륯
        li      r14, 1                  # EOL=yes
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    5: # error:
        b       pop_and_Error

#-------------------------------------------------------------------------
# CodeRead >=
#-------------------------------------------------------------------------
Com_CdRead:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lbz     r0, -4(r17)
        cmpwi   r0, 1                   # Read from file
        beq     2f
        bl      GetFileName
        bl      fropen                  # open
        bso     SYS_Error
        stw     r3, -8(r17)             # FileDesc
        li      r3, 1
        stb     r3, -4(r17)             # Read from file
        mr      r14, r3                 # EOL
    1: # exit
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr
    2: # error
        LWI     r3, error_cdread
        bl      OutAsciiZ
        b       SYS_Error_return

#-------------------------------------------------------------------------
# ̤ޥɽ(顼ȥå)
#-------------------------------------------------------------------------
pop_and_SYS_Error:
        addi    r1, r1, 4               # å
SYS_Error:
        bl      CheckError
SYS_Error_return:
        addi    r1, r1, 4               # å
        bl      WarmInit
        b       MainLoop

#-------------------------------------------------------------------------
# ƥॳ륨顼å
# cr0[so]  OutAscciZ ǥꥻåȤ
#-------------------------------------------------------------------------
CheckError:
        subi    r1, r1, 32
        stswi   r3, r1, 32          # push r3-r10
        mflr    r10                 # save lr

        SETVAR  r3, '|'             # ֤ͤ | 
        bns     1f
        neg     r4, r3
        SETVAR  r4, '|'             # 顼ʤͤ | 

.ifndef  SIMPLE_MSG
        bl      SysCallError
.else
        bns     1f
        LWI     r3, Error_msg
        bl      OutAsciiZ
.endif
    1:  mtlr    r10                 # restore lr
        lswi    r3, r1, 32          # pop r3-r10
        addi    r1, r1, 32          # restore r1
        blr

#-------------------------------------------------------------------------
# FileWrite (=
#-------------------------------------------------------------------------
Com_FileWrite:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lbz     r10, 0(r12)             # check (*=\0
        cmpwi   r10, '*
        bne     1f
        bl      GetChar
        bl      GetChar
        cmpwi   r10, '='
        bne     pop_and_Error
        bl      Exp                     # Get argument
        mr      r3, r0
        b       2f                      # open

    1:  bl      GetFileName
    2:  bl      fwopen                  # open
        bso     SYS_Error
        stw     r3, -12(r17)            # FileDescW

        GETVAR  r4, '{'                 # ǼΰƬ
        GETVAR  r3, '}'                 # Ǽΰǽ
        cmplw   r3, r4
        blt     3f
        sub     r5, r3, r4              # 񤭹ߥ
        lwz     r3, -12(r17)            # FileDescW
        li      r0, sys_write           # ƥॳ
        sc
        bso     SYS_Error
        bl      fclose
    3: # exit:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# FileRead )=
#-------------------------------------------------------------------------
Com_FileRead:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        lbz     r10, 0(r12)             # check )*=\0
        cmpwi   r10, '*
        bne     1f
        bl      GetChar
        bl      GetChar
        cmpwi   r10, '='
        bne     pop_and_Error
        bl      Exp                     # Get argument
        mr      r3, r0
        b       2f                      # open

    1:  bl      GetFileName
    2:  bl      fropen                  # open
        bso     SYS_Error
        stw     r3, -12(r17)            # 裱 : fd
        li      r4, 0                   # 裲 : offset = 0
        li      r5, SEEK_END            # 裳 : origin
        li      r0, sys_lseek           # ե륵
        sc
        mr      r7, r3                  # file_size 
        lwz     r3, -12(r17)            # 裱 : fd
        li      r4, 0                   # 裲 : offset=0
        mr      r5, r4                  # 裳 : origin=0
        li      r0, sys_lseek           # եƬ˥
        sc
        GETVAR  r4, '{'                 # ǼΰƬ
        SETVAR  r7, ')'                 # ɤ߹ߥ
        add     r5, r4, r7              # ǽɥ쥹׻
        SETVAR  r5, '}'                 # Ǽΰǽ
        GETVAR  r3, '*'                 # RAM
        cmplw   r3, r5
        blt     3f                      # r3<r5 ΰ­顼

        mr      r5, r7
        lwz     r3, -12(r17)            # FileDescW
        li      r0, sys_read            # եΤɤߤ
        sc
        mr      r4, r3
        lwz     r3, -12(r17)            # FileDescW
        bl      fclose
        mr      r3, r4                  # set return code
        bso     SYS_Error               # Read Error
    3: # exit
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# λ
#-------------------------------------------------------------------------
Com_Exit:       #   7E  ~  VTLλ
                bl      RESTORE_TERMIOS
                b       Exit

#-------------------------------------------------------------------------
# 桼ĥޥɽ
#-------------------------------------------------------------------------
Com_Ext:
        stwu    r3, -4(r1)          # push r3
        mflr    r3                  # push lr

.ifndef SMALL_VTL
.include        "ext.s"

func_err:
        b       pop_and_Error
.endif
ext_exit:
        mtlr    r3                  # restore lr
        lwzu    r3, 4(r1)           # pop r4
        addi    r1, r1, 4           # restore r1
        blr

#-------------------------------------------------------------------------
# ForkExec , ץμ¹
#-------------------------------------------------------------------------
Com_Exec:
.ifndef SMALL_VTL
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # skip =
        cmpwi   r10, '*
        bne     0f

        bl      SkipEqualExp            # ,*= λ
        bl      GetString2              # FileName˥ԡ
        b       3f

    0:  bl      GetChar                 # skip "
        cmpwi   r10, '"'
        beq     1f
        subi    r12, r12, 1             # ungetc 1ʸ᤹
    1:
        bl      GetString               # ץ̾
      # LWI     r3, FileName            # ե̾ɽ
      # bl      OutAsciiZ
        bl      NewLine
    3:
        bl      ParseArg                # ޥɹԤβ
        mr      r16, r9                 # 쥯ե̾
        addi    r9, r3, 1               # ҥץο
        LWI     r7, exarg               # char ** argp
        li      r8, 0                   # Ƭץ
        cmpwi   r9, 1                   # ҥץο
        bgt     2f                      # ѥפɬ

        # ѥפξ
        li      r0, sys_fork            # ƥॳ
        sc
        and.    r3, r3, r3
        beq     child                   # pid  0 ʤҥץ
        b       6f                      # ҥץλԤä

    2:  # ѥפɬ
        LWI     r6, ipipe               # ѥפ򥪡ץ
        mr      r3, r6                  # r7  pipe_fd Ƭ
        li      r0, sys_pipe            # pipe ƥॳ
        sc

        #------------------------------------------------------------
        # fork
        #------------------------------------------------------------
        li      r0, sys_fork            # ƥॳ
        sc
        and.    r3, r3, r3
        beq     child                   # pid  0 ʤҥץ

        #------------------------------------------------------------
        # ƥץ¦ν
        #------------------------------------------------------------
        and.    r8, r8, r8              # Ƭץ?
        beq     7f
        bl      close_old_pipe          # ƬǤʤХѥץ
    7:  lwz     r5, 0(r6)               # ѥ fd ΰư
        stw     r5, 8(r6)
        lwz     r5, 4(r6)
        stw     r5, 12(r6)
        subic.  r9, r9, 1               # Ĥҥץο
        beq     5f                      # λ

    4:  addi    r7, r7, 4               # Υޥʸõ
        lwz     r5, 0(r7)
        cmpwi   r5, 0                   # ޥɶڤõ
        bne     4b                      # ϥå
        addi    r7, r7, 4               # Υޥʸ
        addi    r8, r8, 1               # ƬץǤϤʤ
        b       2b

    5:  bl      close_new_pipe

    6:  # λԤ r3=Ǹ˵ưҥץpid
        LWI     r4, stat_addr
        li      r5, WUNTRACED           # WNOHANG
        LWI     r6, ru                  # rusage
        li      r0, sys_wait4           # ƥॳ
        sc
        bl      SET_TERMIOS             # ҥץ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

        #------------------------------------------------------------
        # ҥץ¦ν execve¹Ԥʤ
        #------------------------------------------------------------
child:
        bl      RESTORE_TERMIOS
        subic.  r9, r9, 1               # ǽץå
        bne     pipe_out                # ǽץǤʤ
        and.    r16, r16, r16           # 쥯Ȥ뤫
        beq     pipe_in                 # 쥯̵, ɸ
        mr      r3, r16                 # 쥯ե̾
        bl      fwopen                  # r0 = ץ󤷤 fd
        bso     child_exit
        mr      r5, r3                  # fd¸
        li      r4, 1                   # ɸϤե˺ؤ
        li      r0, sys_dup2            # dup2 ƥॳ
        sc
        mr      r3, r5                  # fd
        bl      fclose                  # r3 ˤϥץ󤷤fd
        b       pipe_in

pipe_out:                               # ɸϤѥפ
        lwz     r3, 4(r6)               # ѥפν fd
        li      r4, 1                   # ɸ
        li      r0, sys_dup2            # dup2 ƥॳ
        sc
        bl      close_new_pipe

pipe_in:
        and.    r8, r8, r8              # Ƭץʤ饹å
        beq     execve
                                        # ɸϤѥפ
        lwz     r3, 8(r6)               # ΥѥפɽФ fd
        li      r4, 0                   # new_fd ɸ
        li      r0, sys_dup2            # dup2 ƥॳ
        sc
        bl      close_old_pipe

execve:
        lwz     r3, 0(r7)               # char * filename
        mr      r4, r7                  # char **argp
        LWI     r5, envp                # char **envp
        lwz     r5, 0(r5)
        li      r0, sys_execve          # ƥॳ
        sc
child_exit:
        bl      CheckError              # ʤ餳ˤʤ
        bl      Exit                    # ñʤ

#-------------------------------------------------------------------------
# ѥפΥ 쥸¸
#-------------------------------------------------------------------------
close_new_pipe:
        subi    r1, r1, 8
        stswi   r3, r1, 8               # push r3-r4
        mflr    r4
        lwz     r3, 4(r6)               # ϥѥפ򥯥
        bl      fclose
        lwz     r3, 0(r6)               # ϥѥפ򥯥
        bl      fclose
        b       1f                      # return

#-------------------------------------------------------------------------
# ѥפΥ 쥸¸
#-------------------------------------------------------------------------
close_old_pipe:
        subi    r1, r1, 8
        stswi   r3, r1, 8               # push r3-r4
        mflr    r4
        lwz     r3, 12(r6)              # ϥѥפ򥯥
        bl      fclose
        lwz     r3, 8(r6)               # ϥѥפ򥯥
        bl      fclose
    1:  mtlr    r4                      # restore lr
        lswi    r3, r1, 8               # pop r3-r4
        addi    r1, r1, 8               # restore r1
        blr
.endif

#-------------------------------------------------------------------------
# execve Ѥΰ
# ޥʸΥХåե FileName AsciiZѴƥݥ󥿤
# r3  ѥפο (ҥץ-1) ֤
# r9 ˥쥯ե̾ʸؤΥݥ󥿤֤
# r4,r6,r7,r8 ˲
#-------------------------------------------------------------------------
ParseArg:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        li      r4, 0                   # 󥤥ǥå
        li      r3, 0                   # ѥפΥ
        li      r9, 0                   # 쥯ȥե饰
        LWI     r8, FileName            # ޥʸΥХåե
        LWI     r7, exarg               # ݥ󥿤Ƭ
    1:
        lbz     r0, 0(r8)               # Ϣ³Υå
        and.    r0, r0, r0              # å
        beq     pa_exit
        cmpwi   r0, ' '
        bne     2f                      # ѥפΥå
        addi    r8, r8, 1               # ʤ鼡ʸ
        b       1b

    2:  cmpwi   r0, '|'                 # ѥ?
        bne     3f
        addi    r3, r3, 1               # ѥפΥ+1
        bl      end_mark                # null pointer
        b       6f

    3:  cmpwi   r0, '>'                 # 쥯?
        bne     4f
        li      r9, 1                   # 쥯ȥե饰
        bl      end_mark                # null pointer
        b       6f

    4:  slwi    r6, r4, 2               # ʸƬݥ󥿤
        stwx    r8, r7, r6              # exargϿ
        addi    r4, r4, 1               # 󥤥ǥå+1

    5:  lbz     r0, 0(r8)               # õ
        and.    r0, r0, r0              # å
        beq     7f                      # ʤ齪λ
        cmpwi   r0, ' '
        beq     8f
        addi    r8, r8, 1
        b       5b                      # Ǥʤмʸ
    8:  li      r0, 0
        stb     r0, 0(r8)               # ڡ 0 ִ
        and.    r9, r9, r9              # 쥯ȥե饰
        bne     7f                      # > θϥե̾Τ

    6:  addi    r8, r8, 1               #
        cmpwi   r4, ARGMAX              # ĿåƼ
        bge     pa_exit
        b       1b

    7:  and.    r9, r9, r9              # 쥯ȥե饰
        beq     pa_exit
        subi    r4, r4, 1               # exarg[(r4-1)*4] ˤ
        slwi    r6, r4, 2               # 쥯ȥե̾
        lwzx    r9, r7, r6              # r9 ֤
        addi    r4, r4, 1
pa_exit:
        li      r0, 0
        slwi    r6, r4, 2
        stwx    r0, r7, r6              # ݥκǸ
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

end_mark:
        li      r0, 0
        slwi    r6, r4, 2
        stwx    r0, r7, r6              # ޥɤζڤ NullPtr
        addi    r4, r4, 1               # 󥤥ǥå
        blr

#-------------------------------------------------------------------------
# Ȥ߹ߥޥɤμ¹
#-------------------------------------------------------------------------
Com_Function:
.ifndef SMALL_VTL
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 # | μʸ
func_c:
        cmpwi   r10, 'c'
        bne     func_d
        bl      def_func_c              # |c
        b       func_exit               # return
func_d:
func_e:
        cmpwi   r10, 'e'
        bne     func_f
        bl      def_func_e              # |e
        b       func_exit               # return
func_f:
        cmpwi   r10, 'f'
        bne     func_l
        bl      def_func_f              # |f
        b       func_exit               # return
func_l:
        cmpwi   r10, 'l'
        bne     func_m
        bl      def_func_l              # |l
        b       func_exit               # return
func_m:
        cmpwi   r10, 'm'
        bne     func_n
        bl      def_func_m              # |m
        b       func_exit               # return
func_n:
func_p:
        cmpwi   r10, 'p'
        bne     func_q
        bl      def_func_p              # |p
        b       func_exit               # return
func_q:
func_r:
        cmpwi   r10, 'r'
        bne     func_s
        bl      def_func_r              # |r
        b       func_exit               # return
func_s:
        cmpwi   r10, 's'
        bne     func_t
        bl      def_func_s              # |s
        b       func_exit               # return
func_t:
func_u:
        cmpwi   r10, 'u'
        bne     func_v
        bl      def_func_u              # |u
        b       func_exit               # return
func_v:
        cmpwi   r10, 'v'
        bne     func_z
        bl      def_func_v              # |v
        b       func_exit               # return
func_z:
        cmpwi   r10, 'z'
        bne     pop_and_Error
        bl      def_func_z              # |z
        b       func_exit               # return

#-------------------------------------------------------------------------

#------------------------------------
# |c ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_c:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'a'
        beq     func_ca                 # cat
        cmpwi   r10, 'd'
        beq     func_cd                 # cd
        cmpwi   r10, 'm'
        beq     func_cm                 # chmod
        cmpwi   r10, 'r'
        beq     func_cr                 # chroot
        cmpwi   r10, 'w'
        beq     func_cw                 # pwd
        b       pop2_and_Error
func_ca:
        LWI     r3, msg_f_ca            # |ca file
        bl      FuncBegin
        lwz     r0, 0(r9)               # filename
        bl      DispFile
        b       func_exit               # return
func_cd:
        LWI     r3, msg_f_cd            # |cd path
        bl      FuncBegin
        lwz     r9, 0(r9)               # char ** argp
        LWI     r3, FileName
        bl      OutAsciiZ
        bl      NewLine
        li      r0, sys_chdir           # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return
func_cm:
        LWI     r3, msg_f_cm            # |cm 644 file
        bl      FuncBegin
        lwz     r3, 4(r9)               # file name
        lwz     r4, 0(r9)               # permission
        bl      Oct2Bin
        mr      r4, r9
        li      r0, sys_chmod           # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return
func_cr:
        LWI     r3, msg_f_cr            # |cr path
        bl      FuncBegin
        lwz     r4, 0(r9)               # char ** argp
        LWI     r3, FileName
        bl      OutAsciiZ
        bl      NewLine
        li      r0, sys_chroot          # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return
func_cw:
        LWI     r3, msg_f_cw            # |cw
        bl      OutAsciiZ
        LWI     r3, FileName
        mr      r5, r3                  # save r3
        li      r4, FNAMEMAX
.ifdef MACOSX
.else
        li      r0, sys_getcwd          # ƥॳ
        sc
.endif
        bl      CheckError
        mr      r3, r5                  # restore r3
        bl      OutAsciiZ
        bl      NewLine
        b       func_exit               # return

#------------------------------------
# |e ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_e:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'x'
        beq     func_ex                 # execve
        b       pop2_and_Error
func_ex:
        LWI     r3, msg_f_ex            # |ex file arg ..
        bl      RESTORE_TERMIOS         # ü᤹
        bl      FuncBegin               # r9: char ** argp
        mr      r4, r9
        lwz     r3, 0(r9)               # char * filename
        lwz     r5, -4(r9)              # char ** envp
        li      r0, sys_execve          # ƥॳ
        sc
        bl      CheckError              # ʤ餳ˤʤ
        bl      SET_TERMIOS             # üΥ륨OFF
        b       func_exit               # return

#------------------------------------
# |f ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_f:
.ifdef FRAME_BUFFER
.include        "vtlfb.s"
.endif

#------------------------------------
# |l ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_l:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 's'
        beq     func_ls                 # ls
        b       pop2_and_Error

func_ls:
        LWI     r3, msg_f_ls            # |ls dir
        bl      FuncBegin
        lwz     r4, 0(r9)
        and.    r4, r4, r4
        bne     1f
        LWI     r4, current_dir         # dir ʤ
    1:  LWI     r3, DirName
        mr      r0, r3
    2:  lbz     r8, 0(r4)               # dir DirName˥ԡ
        stb     r8, 0(r3)
        addi    r4, r4, 1
        addi    r3, r3, 1
        and.    r8, r8, r8
        bne     2b

        lbz     r8, -2(r3)              # dir/å
        li      r4, '/
        cmpw    r8, r4
        beq     3f                      # / ͭ
        stb     r4, -1(r3)              # / 񤭹
        li      r4, 0                   # ʸޡɲ
        stb     r4, 0(r3)               # end mark
    3:
        mr      r3, r0
        bl      fropen
        bso     6f                      # 顼åƽλ
        mr      r7, r3                  # fd ¸
        LWI     r25, DirName            # for GetFileStat

    4:  # ǥ쥯ȥꥨȥ
        # unsigned int fd, void * dirent, unsigned int count
        mr      r3, r7                  # fd 
        LWI     r4, dir_ent             # ХåեƬ
        mr      r6, r4                  # r6 : struct top (dir_ent)
        LWI     r5, size_dir_ent
.ifdef MACOSX
.else
        li      r0, sys_getdents        # ƥॳ
        sc
.endif
        bso     6f
        and.    r3, r3, r3
        beq     7f


        # dir_entե
        mr      r5, r3                  # size
    5:  mr      r4, r6                  # r6 : dir_ent
        bl      GetFileStat             # r4:dir_entɥ쥹
        LWI     r8, file_stat
        lwz     r3, 8(r8)               # file_stat.st_mode
        li      r4, 6
        bl      PrintOctal              # mode
        lwz     r3, 28(r8)              # file_stat.st_size
        li      r4, 12
        bl      PrintRight              # file size
        li      r3, ' '
        bl      OutChar
        addi    r3, r6, 10              # dir_ent.filename
        bl      OutAsciiZ               # filename
        bl      NewLine
        lhz     r0, 8(r6)               # record length
        sub.    r5, r5, r0              # ХåեλĤ
        ble     4b                      # Υǥ쥯ȥꥨȥ
        add     r6, r6, r0              # dir_ent
        b       5b

    6:  bl      CheckError
    7:  mr      r3, r7                  # fd
        bl      fclose
        b       func_exit               # return

#------------------------------------
# |m ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_m:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'd'
        beq     func_md                 # mkdir
        cmpwi   r10, 'o'
        beq     func_mo                 # mo
        cmpwi   r10, 'v'
        beq     func_mv                 # mv
        b       pop2_and_Error

func_md:
        LWI     r3, msg_f_md            # |md dir [777]
        bl      FuncBegin
        lwz     r4, 4(r9)               # permission
        lwz     r3, 0(r9)               # directory name
        bl      OutAsciiZ
        and.    r4, r4, r4
        bne     1f
        li      r9, 0755
        b       2f
    1:  bl      Oct2Bin
    2:  mr      r4, r9
        li      r0, sys_mkdir           # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

func_mo:
        LWI     r3, msg_f_mo            # |mo dev_name dir fstype
        bl      FuncBegin
        lwz     r3, 0(r9)               # dev_name
        lwz     r4, 4(r9)               # dir_name
        lwz     r5, 8(r9)               # fstype
        lwz     r6, 12(r9)              # flags
        and.    r6, r6, r6              # Check ReadOnly
        beq     1f                      # Read/Write
        li      r6, MS_RDONLY           # ReadOnly FileSystem
    1:
        li      r7, 0                   # void * data
        li      r0, sys_mount           # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return
func_mv:
        LWI     r3, msg_f_mv            # |mv fileold filenew
        bl      FuncBegin
        lwz     r3, 0(r9)
        lwz     r4, 4(r9)
        li      r0, sys_rename          # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

#------------------------------------
# |p ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_p:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'v'
        beq     func_pv                 # pivot_root
        b       pop2_and_Error

func_pv:
        LWI     r3, msg_f_pv            # |pv /dev/hda2 /mnt
        bl      FuncBegin
        lwz     r3, 0(r9)
        lwz     r4, 4(r9)
.ifdef MACOSX
.else
        li      r0, sys_pivot_root      # ƥॳ
        sc
.endif
        bl      CheckError
        b       func_exit               # return

#------------------------------------
# |r ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_r:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'd'
        beq     func_rd                 # rmdir
        cmpwi   r10, 'm'
        beq     func_rm                 # rm
        b       pop2_and_Error

func_rd:
        LWI     r3, msg_f_rd            # |rd path
        bl      FuncBegin               # char ** argp
        lwz     r3, 0(r9)
        li      r0, sys_rmdir           # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

func_rm:
        LWI     r3, msg_f_rm            # |rm path
        bl      FuncBegin               # char ** argp
        lwz     r3, 0(r9)
        li      r0, sys_unlink          # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

#------------------------------------
# |s ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_s:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'f'
        beq     func_sf                 # swapoff
        cmpwi   r10, 'o'
        beq     func_so                 # swapon
        cmpwi   r10, 'y'
        beq     func_sy                 # sync
        b       pop2_and_Error

func_sf:
        LWI     r3, msg_f_sf            # |sf dev_name
        bl      FuncBegin               # const char * specialfile
        lwz     r3, 0(r9)
.ifdef MACOSX
.else
        li      r0, sys_swapoff         # ƥॳ
        sc
.endif
        bl      CheckError
        b       func_exit               # return

func_so:
        LWI     r3, msg_f_so            # |so dev_name
        bl      FuncBegin
        lwz     r3, 0(r9)               # const char * specialfile
        li      r4, 0                   # int swap_flags
        li      r0, sys_swapon          # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

func_sy:
        LWI     r3, msg_f_sy            # |sy
        li      r0, sys_sync            # ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return

#------------------------------------
# |u ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_u:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'm'
        beq     func_um                 # umount
        cmpwi   r10, 'd'
        beq     func_ud                 # URL Decode
        b       pop2_and_Error

func_um:
.ifdef MACOSX
        b       pop2_and_Error
.else
        LWI     r3, msg_f_um            # |um dev_name
        bl      FuncBegin               #
        lwz     r3, 0(r9)               # dev_name
        li      r0, sys_umount          #s_oldumount ƥॳ
        sc
        bl      CheckError
        b       func_exit               # return
.endif

func_ud:
        #------------------------------------
        # URL ǥ
        #  u[0] URL󥳡ʸƬ
        #  u[1] ѹϰϤʸ
        #  u[2] ǥɸʸƬ
        #  u[3] ǥɸʸ֤
        #------------------------------------
        GETVAR  r7, 'u                  #  u[0] - u[3]
        lwz     r3, 0(r7)               # r3 URL󥳡ʸƬ
        lwz     r4, 4(r7)               # r4 ѹϰϤʸ
        lwz     r5, 8(r7)               # r5 ˥ǥɸʸƬ
        bl      URL_Decode
        stw     r0, 12(r7)              # ǥɸʸ
        b       func_exit               # return

#------------------------------------
# |v ǻϤޤȤ߹ߥޥ
#------------------------------------
def_func_v:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'e'
        beq     func_ve                 # version
        b       pop2_and_Error

func_ve:
        LWI     r4, VERSION
        SETVAR  r4, '%                  #
        b       func_exit               # return

#------------------------------------
# |zz ƥॳ
#------------------------------------
def_func_z:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'z'
        beq     func_zz                 # system bl
        b       pop2_and_Error

func_zz:
        GETVAR  r0, 'a'
        GETVAR  r3, 'b'
        GETVAR  r4, 'c'
        GETVAR  r5, 'd'
        GETVAR  r7, 'f'
        GETVAR  r6, 'e'
        sc
        bl      CheckError
func_exit:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#---------------------------------------------------------------------
# r8 ʸ16ʿɤΥå
# ʤѴ r8 ֤. ʤ饵ޥꥪХեå
#---------------------------------------------------------------------

IsNum2: cmpwi   cr2, r8, '0'            # r10 < '0'  cr2[lt]=1
        cmpwi   cr3, r8, '9'            # r10 > '9'  cr3[gt]=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

IsHex:
        stwu    r3, -4(r1)              # push r3
        mflr    r3                      # save lr
        bl      IsHex1                  # ʸ(A-F)?
        bso     1f                      # no
        subi    r8, r8, 'A
        b       2f
    1:  bl      IsHex2                  # Ѿʸ(a-f)?
        bso     3f                      # no
        subi    r8, r8, 'a
    2:  addi    r8, r8, 10
    3:  mtlr    r3                      # restore lr
        lwz     r3, 0(r1)               # pop r3
        addi    r1, r1, 4               # restore r1
        blr

IsHex1:
        cmpwi   cr2, r8, 'A             # ʸ(A-Z)?
        cmpwi   cr3, r8, 'F             # if r8>'Z' gt=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

IsHex2:
        cmpwi   cr2, r8, 'a             # ʸ(A-Z)?
        cmpwi   cr3, r8, 'f             # if r8>'z' gt=1
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        blr

IsHexNum:
        subi    r1, r1, 8
        stswi   r3, r1, 8               # push r3-r4
        mflr    r4                      # save lr
        bl      IsHex                   # ʸ?
        bns     1f                      # yes
        bl      IsNum2                  # ?
        bso     1f
        subi    r8, r8, '0'             # Ѵ
    1:
        mtlr    r4                      # restore lr
        lswi    r3, r1, 8               # pop r3-r4
        addi    r1, r1, 8               # restore r1
        blr

#-------------------------------------------------------------------------
# URLǥ
#
# r3 URL󥳡ʸƬ
# r4 ѹϰϤʸ
# r5 ˥ǥɸʸƬ
# r0 ˥ǥɸʸ֤
#-------------------------------------------------------------------------
URL_Decode:
        subi    r1, r1, 32
        stswi   r3, r1, 32          # push r3-r10
        mflr    r10                 # save lr
        add     r9, r3, r4
        subi    r9, r9, 1
        li      r6, 0
        subi    r3, r3, 1
    1:
        lbzu    r7, 1(r3)
        cmpwi   r7, '+
        bne     2f
        li      r7, ' '
        stbx    r7, r5, r6
        b       4f
    2:  cmpwi   r7, '%
        beq     3f
        stbx    r7, r5, r6
        b       4f

    3:
        li      r7, 0
        lbzu    r8, 1(r3)
        bl      IsHexNum
        bso     4f
        add     r7, r7, r8
        lbzu    r8, 1(r3)
        bl      IsHexNum
        bso     4f
        slwi    r7, r7, 4
        add     r7, r7, r8
        stbx    r7, r5, r6
    4:
        addi    r6, r6, 1
        cmplw   r3, r9
        blt     1b

        li      r7, 0
        stbx    r7, r5, r6
        mr      r0, r6              # ʸ֤
        mtlr    r10                 # restore lr
        lswi    r3, r1, 32          # pop r3-r10
        addi    r1, r1, 32          # restore r1
        blr

#-------------------------------------------------------------------------
# Ȥ߹ߴؿ
#-------------------------------------------------------------------------
FuncBegin:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      OutAsciiZ
        bl      GetChar                 # get *
        cmpwi   r10, '*
        bne     1f
        bl      SkipEqualExp            # r0 ˥ɥ쥹
        mr      r4, r13                 # r13
        mr      r13, r0                 # RangeCheckr13򸫤
        bl      RangeCheck              # ԡϰϥå
        mr      r13, r4                 # ԡ
        bso     4f                      # ϰϳ򥢥
        bl      GetString2              # FileName˥ԡ
        b       3f
    1:  lbz     r3, 0(r12)
        cmpwi   r3, '"'
        beql    GetChar                 # skip "
    2:  bl      GetString               # ѥ̾μ
    3:  bl      ParseArg                # Υѡ
        LWI     r9, exarg
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    4:  li      r10, 0xFF               # 顼ʸ FF
        b       LongJump                # ǽϰϤĶ

#-------------------------------------------------------------------------
# 8ʿʸͤѴ
# r4 8ʿʸͤѴ r9 ֤
#-------------------------------------------------------------------------
Oct2Bin:
        mflr    r5
        stwu    r5, -4(r1)              # push lr
        bl      GetOctal                # r9
        bso     2f                      # exit
        mr      r5, r9
    1:
        bl      GetOctal
        bso     2f
        slwi    r6, r5, 3
        add     r5, r6, r9
        b       1b
    2:
        mr      r9, r5
        lwz     r5, 0(r1)               # pop lr
        mtlr    r5                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

#-------------------------------------------------------------------------
# r0 μ8ʿʸͤѴ r9 ֤
# 8ʿʸǤʤɤ bgtȽǽ
#-------------------------------------------------------------------------
GetOctal:
        lbz     r9, 0(r4)
        addi    r4, r4, 1
        cmpwi   cr2, r9, '0             # 0-7 ?
        cmpwi   cr3, r9, '7
        cror    3, 8, 13                # cr0[so] = cr2[lt] | cr3[gt]
        bso     1f
        subi    r9, r9, '0
1:      blr

#-------------------------------------------------------------------------
# եɽ
# r0 ˥ե̾
#-------------------------------------------------------------------------
DispFile:
        mflr    r4
        stwu    r4, -4(r1)              # push lr
        mr      r3, r0                  # FileDesc
        bl      fropen                  # open
        bso     4f
        mr      r7, r3
        subi    r1, r1, 4               # push r0, buffer
        li      r5, 4                   # r5  length
        mr      r4, r1                  # r4  address
    1:  li      r0, sys_read
        mr      r3, r7                  # fd
        sc
        and.    r3, r3, r3
        beq     2f
        mr      r5, r3                  # length
        li      r3, 1                   # r3  stdout
        li      r0, sys_write
        sc
        b       1b
    2:
        addi    r1, r1, 4               # free buffer
        mr      r3, r7                  # fd
        bl      fclose
    3:
        lwz     r4, 0(r1)               # pop lr
        mtlr    r4                      # restore lr
        addi    r1, r1, 4               # restore r1
        blr

    4:  bl      CheckError              # cr0[so]ϥꥻåȤ
        b       3b
.endif

#==============================================================
.data

#-------------------------------------------------------------------------
# ޥѥץơ֥
#-------------------------------------------------------------------------
        .align   2
TblComm1:
        .long Com_GOSUB    #   21  !  GOSUB
        .long Com_String   #   22  "  ʸ
        .long Com_GO       #   23  #  GOTO ¹ιֹݻ
        .long Com_OutChar  #   24  $  ʸɽ
        .long Com_Error    #   25  %  ľνξ;ޤ usec ݻ
        .long Com_NEW      #   26  &  NEW, VTLɤκǽѥɥ쥹ݻ
        .long Com_Error    #   27  '  ʸ
        .long Com_FileWrite#   28  (  File 񤭽Ф
        .long Com_FileRead #   29  )  File ɤ߹, ɤ߹ߥݻ
        .long Com_BRK      #   2A  *  ǽ(brk), ݻ
        .long Com_VarPush  #   2B  +  ѿPUSH, û黻, 
        .long Com_Exec     #   2C  ,  fork & exec
        .long Com_VarPop   #   2D  -  ѿPOP, 黻, νʿ
        .long Com_Space    #   2E  .  
        .long Com_NewLine  #   2F  /  Խ, 黻
TblComm2:
        .long Com_Comment  #   3A  :  ޤ
        .long Com_IF       #   3B  ;  IF
        .long Com_CdWrite  #   3C  <  rvtlɤΥե
        .long Com_Top      #   3D  =  Ƭɥ쥹
        .long Com_CdRead   #   3E  >  rvtlɤΥե
        .long Com_OutNum   #   3F  ?  ͽ  
        .long Com_DO       #   40  @  DO UNTIL NEXT
TblComm3:
        .long Com_RCheck   #   5B  0(  Array index ϰϥå
        .long Com_Ext      #   5C  \  ĥ  黻(unsigned)
        .long Com_Return   #   5D  )  RETURN
        .long Com_Comment  #   5E  ^  ٥, ¾OR黻, ٥뻲
        .long Com_USleep   #   5F  _  usleep, gettimeofday
        .long Com_RANDOM   #   60  `  ݻ ()
TblComm4:
        .long Com_FileTop  #   7B  {  եƬ(ҡΰ)
        .long Com_Function #   7C  |  Ȥ߹ߥޥ, 顼ݻ
        .long Com_FileEnd  #   7D  }  ե(ҡΰ)
        .long Com_Exit     #   7E  ~  VTLλ
#-------------------------------------------------------------------------


.ifndef SMALL_VTL
                .align   2
start_msg:      .ascii   "RVTL v.3.03 2005/06/19, (C)2005 Jun Mizutani\n"
                .ascii   "RVTL may be copied under the terms of the GNU "
                .asciz   "General Public License.\n"
                .align   2
.endif

cginame:        .asciz   "wltvr"
                .align   2
initvtl:        .asciz   "/etc/init.vtl"
                .align   2
err_div0:       .asciz   "\nDivided by 0!\n"
                .align   2
err_label:      .asciz   "\nLabel not found!\n"
                .align   2
err_vstack:     .asciz   "\nEmpty stack!\n"
                .align   2
err_exp:        .asciz   "\nError in Expression at line "

                .align  2
err_str:
                .asciz  "^  ["
                .align  2

envstr:         .asciz   "PATH=/bin:/usr/bin"
                .align   2
env:            .long    envstr, 0
                .align   2
prompt1:        .asciz   "\n<"
                .align   2
prompt2:        .asciz   "> "
                .align   2
syntaxerr:      .asciz   "\nSyntax error! at line "
                .align   2
stkunder:       .asciz   "\nLoop Stack Underflow!\n"
                .align   2
stkover:        .asciz   "\nLoop Stack Overflow!\n"
                .align   2
vstkunder:      .asciz   "\nVariable Stack Underflow!\n"
                .align   2
vstkover:       .asciz   "\nVariable Stack Overflow!\n"
                .align   2
Range_msg:      .asciz   "\nOut of range!\n"
                .align   2
no_direct_mode: .asciz   "\nDirect mode is not allowed!\n"
                .align   2
equal_err:      .asciz   "\n= reqiured."
                .align   2
EndMark_msg:    .asciz   "\n&=0 required.\n"
                .align   2
error_cdread:   .asciz   "\nCode Read (>=) is not allowed!\n"
                .align   2
Error_msg:      .asciz   "\nError!\n"
                .align   2

#-------------------------------------------------------------------------
# Ȥ߹ߴؿѥå
#-------------------------------------------------------------------------
.ifndef SMALL_VTL
                .align  2
    msg_f_ca:   .asciz  ""
                .align  2
    msg_f_cd:   .asciz  "Change Directory to "
                .align  2
    msg_f_cm:   .asciz  "Change Permission \n"
                .align  2
    msg_f_cr:   .asciz  "Change Root to "
                .align  2
    msg_f_cw:   .asciz  "Current Working Directory : "
                .align  2
    msg_f_ex:   .asciz  "Exec Command\n"
                .align  2
    msg_f_ls:   .asciz  "List Directory\n"
                .align  2
    msg_f_md:   .asciz  "Make Directory\n"
                .align  2
    msg_f_mv:   .asciz  "Change Name\n"
                .align  2
    msg_f_mo:   .asciz  "Mount\n"
                .align  2
    msg_f_pv:   .asciz  "Pivot Root\n"
                .align  2
    msg_f_rd:   .asciz  "Remove Directory\n"
                .align  2
    msg_f_rm:   .asciz  "Remove File\n"
                .align  2
    msg_f_sf:   .asciz  "Swap Off\n"
                .align  2
    msg_f_so:   .asciz  "Swap On\n"
                .align  2
    msg_f_sy:   .asciz  "Sync\n"
                .align  2
    msg_f_um:   .asciz  "Unmount\n"
                .align  2
.endif

#==============================================================
.section    ".bss"

                .align   2
new_sig:
nsa_sighandler:     .long   0           #  0
nsa_mask:           .long   0           #  4
nsa_flags:          .long   0           #  8
nsa_restorer:       .long   0           # 12
old_sig:
osa_sighandler:     .long   0           # 16
osa_mask:           .long   0           # 20
osa_flags:          .long   0           # 24
osa_restorer:       .long   0           # 28

TV:
tv_sec:             .long   1
tv_usec:            .long   1
TZ:
tz_minuteswest:     .long   1
tz_dsttime:         .long   1

cgiflag:       .long   0
save_stack:    .long   0
current_arg:   .long   0
argc:          .long   0
argvp:         .long   0
envp:          .long   0
argc_vtl:      .long   0
argp_vtl:      .long   0
exarg:         .skip   (ARGMAX+1)*4     # execve 
ipipe:         .long   0
opipe:         .long   0
ipipe2:        .long   0
opipe2:        .long   0
stat_addr:     .long   0

                .align  2
input2:        .skip   MAXLINE
FileName:      .skip   FNAMEMAX
pid:           .long   0               # r17-24
FOR_direct:    .byte   0               # r17-20
ExpError:      .byte   0               # r17-19
ZeroDiv:       .byte   0               # r17-18
SigInt:        .byte   0               # r17-17
VSTACK:        .long   0               # r17-16
FileDescW:     .long   0               # r17-12
FileDesc:      .long   0               # r17-8
ReadFrom:      .byte   0               # r17-4
ExecMode:      .byte   0               # r17-3
EOL:           .byte   0               # r17-2
LSTACK:        .byte   0               # r17-1
VarArea:       .skip   256*4           # r17    Ⱦ128dwordLSTACK
VarStack:      .skip   VSTACKMAX*4     # r17+1024

.ifdef VTL_LABEL
                .align  2
LabelTable:    .skip   LABELMAX*16     # 1024*16 bytes
TablePointer:  .long   0
.endif
                .align  2
CodeArea:      .skip   MEMINIT         # Code & Data & Heap

