#-------------------------------------------------------------------------
#  file : syscall.s
#  2004/07/23
#  derived from linux-2.6.7/include/asm-ppc/unistd.h
#-------------------------------------------------------------------------

.ifndef __SYSCALL
__SYSCALL = 1

.ifdef MACOSX
.include "syscalls-mac.s"
.else

sys_restart_syscall     =  0
sys_exit                =  1
sys_fork                =  2
sys_read                =  3
sys_write               =  4
sys_open                =  5
sys_close               =  6
sys_waitpid             =  7
sys_creat               =  8
sys_link                =  9
sys_unlink              = 10
sys_execve              = 11
sys_chdir               = 12
sys_time                = 13
sys_mknod               = 14
sys_chmod               = 15
sys_lchown              = 16
sys_break               = 17
sys_oldstat             = 18
sys_lseek               = 19
sys_getpid              = 20
sys_mount               = 21
sys_umount              = 22
sys_setuid              = 23
sys_getuid              = 24
sys_stime               = 25
sys_ptrace              = 26
sys_alarm               = 27
sys_oldfstat            = 28
sys_pause               = 29
sys_utime               = 30
sys_stty                = 31
sys_gtty                = 32
sys_access              = 33
sys_nice                = 34
sys_ftime               = 35
sys_sync                = 36
sys_kill                = 37
sys_rename              = 38
sys_mkdir               = 39
sys_rmdir               = 40
sys_dup                 = 41
sys_pipe                = 42
sys_times               = 43
sys_prof                = 44
sys_brk                 = 45
sys_setgid              = 46
sys_getgid              = 47
sys_signal              = 48
sys_geteuid             = 49
sys_getegid             = 50
sys_acct                = 51
sys_umount2             = 52
sys_lock                = 53
sys_ioctl               = 54
sys_fcntl               = 55
sys_mpx                 = 56
sys_setpgid             = 57
sys_ulimit              = 58
sys_oldolduname         = 59
sys_umask               = 60
sys_chroot              = 61
sys_ustat               = 62
sys_dup2                = 63
sys_getppid             = 64
sys_getpgrp             = 65
sys_setsid              = 66
sys_sigaction           = 67
sys_sgetmask            = 68
sys_ssetmask            = 69
sys_setreuid            = 70
sys_setregid            = 71
sys_sigsuspend          = 72
sys_sigpending          = 73
sys_sethostname         = 74
sys_setrlimit           = 75
sys_getrlimit           = 76
sys_getrusage           = 77
sys_gettimeofday        = 78
sys_settimeofday        = 79
sys_getgroups           = 80
sys_setgroups           = 81
sys_select              = 82
sys_symlink             = 83
sys_oldlstat            = 84
sys_readlink            = 85
sys_uselib              = 86
sys_swapon              = 87
sys_reboot              = 88
sys_readdir             = 89
sys_mmap                = 90
sys_munmap              = 91
sys_truncate            = 92
sys_ftruncate           = 93
sys_fchmod              = 94
sys_fchown              = 95
sys_getpriority         = 96
sys_setpriority         = 97
sys_profil              = 98
sys_statfs              = 99
sys_fstatfs             =100
sys_ioperm              =101
sys_socketcall          =102
sys_syslog              =103
sys_setitimer           =104
sys_getitimer           =105
sys_stat                =106
sys_lstat               =107
sys_fstat               =108
sys_olduname            =109
sys_iopl                =110
sys_vhangup             =111
sys_idle                =112
sys_vm86                =113
sys_wait4               =114
sys_swapoff             =115
sys_sysinfo             =116
sys_ipc                 =117
sys_fsync               =118
sys_sigreturn           =119
sys_clone               =120
sys_setdomainname       =121
sys_uname               =122
sys_modify_ldt          =123
sys_adjtimex            =124
sys_mprotect            =125
sys_sigprocmask         =126
sys_create_module       =127
sys_init_module         =128
sys_delete_module       =129
sys_get_kernel_syms     =130
sys_quotactl            =131
sys_getpgid             =132
sys_fchdir              =133
sys_bdflush             =134
sys_sysfs               =135
sys_personality         =136
sys_afs_syscall         =137    # Syscall for Andrew File System
sys_setfsuid            =138
sys_setfsgid            =139
sys__llseek             =140
sys_getdents            =141
sys__newselect          =142
sys_flock               =143
sys_msync               =144
sys_readv               =145
sys_writev              =146
sys_getsid              =147
sys_fdatasync           =148
sys__sysctl             =149
sys_mlock               =150
sys_munlock             =151
sys_mlockall            =152
sys_munlockall          =153
sys_sched_setparam      =154
sys_sched_getparam      =155
sys_sched_setscheduler  =156
sys_sched_getscheduler  =157
sys_sched_yield         =158
sys_sched_get_priority_max      =159
sys_sched_get_priority_min      =160
sys_sched_rr_get_interval       =161
sys_nanosleep           =162
sys_mremap              =163
sys_setresuid           =164
sys_getresuid           =165
sys_query_module        =166
sys_poll                =167
sys_nfsservctl          =168
sys_setresgid           =169
sys_getresgid           =170
sys_prctl               =171
sys_rt_sigreturn        =172
sys_rt_sigaction        =173
sys_rt_sigprocmask      =174
sys_rt_sigpending       =175
sys_rt_sigtimedwait     =176
sys_rt_sigqueueinfo     =177
sys_rt_sigsuspend       =178
sys_pread64             =179
sys_pwrite64            =180
sys_chown               =181
sys_getcwd              =182
sys_capget              =183
sys_capset              =184
sys_sigaltstack         =185
sys_sendfile            =186
sys_getpmsg             =187    # some people actually want streams
sys_putpmsg             =188    # some people actually want streams
sys_vfork               =189
sys_ugetrlimit          =190    # SuS compliant getrlimit
sys_readahead           =191
sys_mmap2               =192
sys_truncate64          =193
sys_ftruncate64         =194
sys_stat64              =195
sys_lstat64             =196
sys_fstat64             =197
sys_pciconfig_read      =198
sys_pciconfig_write     =199
sys_pciconfig_iobase    =200
sys_multiplexer         =201
sys_getdents64          =202
sys_pivot_root          =203
sys_fcntl64             =204
sys_madvise             =205
sys_mincore             =206
sys_gettid              =207
sys_tkill               =208
sys_setxattr            =209
sys_lsetxattr           =210
sys_fsetxattr           =211
sys_getxattr            =212
sys_lgetxattr           =213
sys_fgetxattr           =214
sys_listxattr           =215
sys_llistxattr          =216
sys_flistxattr          =217
sys_removexattr         =218
sys_lremovexattr        =219
sys_fremovexattr        =220
sys_futex               =221
sys_sched_setaffinity   =222
sys_sched_getaffinity   =223
/* 224 currently unused */
sys_tuxcall             =225
sys_sendfile64          =226
sys_io_setup            =227
sys_io_destroy          =228
sys_io_getevents        =229
sys_io_submit           =230
sys_io_cancel           =231
sys_set_tid_address     =232
sys_fadvise64           =233
sys_exit_group          =234
sys_lookup_dcookie      =235
sys_epoll_create        =236
sys_epoll_ctl           =237
sys_epoll_wait          =238
sys_remap_file_pages    =239
sys_timer_create        =240
sys_timer_settime       =241
sys_timer_gettime       =242
sys_timer_getoverrun    =243
sys_timer_delete        =244
sys_clock_settime       =245
sys_clock_gettime       =246
sys_clock_getres        =247
sys_clock_nanosleep     =248
sys_swapcontext         =249
sys_tgkill              =250
sys_utimes              =251
sys_statfs64            =252
sys_fstatfs64           =253
sys_fadvise64_64        =254
sys_rtas                =255
# Number 256 is reserved for sys_debug_setcontext
# Number 257 is reserved for vserver
# Number 258 is reserved for new sys_remap_file_pages
# Number 259 is reserved for new sys_mbind
# Number 260 is reserved for new sys_get_mempolicy
# Number 261 is reserved for new sys_set_mempolicy
sys_mq_open             =262
sys_mq_unlink           =263
sys_mq_timedsend        =264
sys_mq_timedreceive     =265
sys_mq_notify           =266
sys_mq_getsetattr       =267
sys_kexec_load          =268

sys_syscalls            =269

.endif
.endif
