#-------------------------------------------------------------------------
# Return of the Very Tiny Language for PowerPC
# file : vtllib.s
# 2005/04/11,18,20,21,22,23,05/08-10
# Copyright (C) 2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
# vtllib.s may be copied under the terms of the GNU General Public License.
#-------------------------------------------------------------------------

.ifndef __VTLLIB
__VTLLIB = 1

.include "syscalls.s"
.include "termio.s"
.include "stdio.s"

.ifndef  SIMPLE_MSG
.include "syserror.s"
.endif

#==============================================================
.text

MAXLINE      = 128         # Maximum Line Length
MAX_FILE     = 256         # Maximum Filename
MAXHISTORY   =  16         # No. of history buffer

# from include/linux/wait.h
WNOHANG   = 0x00000001
WUNTRACED = 0x00000002

# from include/asm-ppc/fcntl.h
O_ACCMODE   =    0003
O_RDONLY    =     00
O_WRONLY    =     01
O_RDWR      =     02
O_CREAT     =      0100     /* not fcntl */
O_EXCL      =      0200     /* not fcntl */
O_NOCTTY    =      0400     /* not fcntl */
O_TRUNC     =     01000     /* not fcntl */
O_APPEND    =     02000
O_NONBLOCK  =     04000
O_NDELAY    =    O_NONBLOCK
O_SYNC      =    010000
FASYNC      =    020000     /* fcntl, for BSD compatibility */
O_DIRECTORY =    040000     /* must be a directory */
O_NOFOLLOW  =    0100000    /* don't follow links */
O_LARGEFILE =    0200000
O_DIRECT    =    0400000    /* direct disk access hint */

# from include/linux/fs.h
MS_RDONLY       =   1       /* Mount read-only */
MS_NOSUID       =   2       /* Ignore suid and sgid bits */
MS_NODEV        =   4       /* Disallow access to device special files */
MS_NOEXEC       =   8       /* Disallow program execution */
MS_SYNCHRONOUS  =   16      /* Writes are synced at once */
MS_REMOUNT      =   32      /* Alter flags of a mounted FS */
MS_MANDLOCK     =   64      /* Allow mandatory locks on an FS */
MS_NOATIME      =   1024    /* Do not update access times. */
MS_NODIRATIME   =   2048    /* Do not update directory access times */
MS_BIND         =   4096
MS_REC          =   16384
MS_VERBOSE      =   32768
MS_ACTIVE       =   (1<<30)
MS_NOUSER       =   (1<<31)

/*------------------------------------------------------------------------
  r0,r20-r31 ¸ʤŪˤϼΤ褦˻ѤƤ
  r2,r10-r19 ϻѤʤr3-r9 ¸롣
    r0    : 
    r3-r9 : 
    r20   : Input Buffer
    r21   : BufferSize
    r22   : history string ptr
    r23   :          (0..r21-1)
    r24   : current position (0..r21-1)  memory address[r20+r24]
    r25   : DirName
    r26   : FNArray ե̾ؤΥݥ(FileCompletion)
    r27   : PartialName ϥХåեؤΥݥ
    r28   : FileNameBuffer(FileCompletion)
    r29   : FNBPointer
    r30   : ѥ쥸
    r31   : FNCount, ѥ쥸
------------------------------------------------------------------------*/

#-------------------------------------------------------------------------
# Ƭޡ
#   r3 : Ƭޡ
#   r30 : ˲
#-------------------------------------------------------------------------
        .align  2
set_linetop:
        LWI     r30, LINE_TOP
        stw     r3, 0(r30)
        blr

#-------------------------------------------------------------------------
# Խդ(ʸդ)
#   r3:Хåե, r4:ХåեƬ
#   r0 ʸ֤
#   r30, r31 ˲
#-------------------------------------------------------------------------
READ_LINE2:
        LWI     r30, LINE_TOP
        lwz     r31, 0(r30)
        stw     r31, 4(r30)         # FLOATING_TOP=LINE_TOP

        subi    r1, r1, 24
        stswi   r3, r1, 24          # push r3-r8
        mflr    r8                  # save lr

        mr      r7, r3              # Хåե
        mr      r3, r4              # ϥХåեɽ
        bl      OutAsciiZ
        bl      StrLen              # <r3:ɥ쥹, >r0:ʸ
        mr      r23, r0             # 
        mr      r3, r7              # Хåե
        b       RL_0

#-------------------------------------------------------------------------
# Խդ
#   r3:Хåե, r4:ХåեƬ
#   r0 ʸ֤
#   ֤ƹƬ¸, ʣԤˤ錄ڡԲ
#   ƤӽФκޡȤ
#-------------------------------------------------------------------------
READ_LINE3:
        mflr    r30
        bl      get_cursor_position
        mtlr    r30
        b       RL

#--------------------------------------------------------------
# ֤ READ_LINE3 ǻ
#   r0ʳ쥸¸
#--------------------------------------------------------------
get_cursor_position:
        subi    r1, r1, 8
        stswi   r3, r1, 8           # push r3-r4
        mflr    r4                  # save lr

        LWI     r3, CURSOR_REPORT
        bl      OutPString
        bl      InChar              # ֤ʸ
        cmpwi   r0, 0x1B            # ^[[y;xR
        bne     1f
        bl      InChar
        cmpwi   r0, '['
        bne     1f
        bl      get_decimal         # skip Y
        bl      get_decimal         # X
        subi    r0, r3, 1           # r0 = X -1
        LWI     r3, FLOATING_TOP
        stw     r0, 0(r3)           # ޡ
    1:
        mtlr    r4                  # restore lr
        lswi    r3, r1, 8           # pop r3-r4
        addi    r1, r1, 8           # restore r1
        blr

#--------------------------------------------------------------
# ɸϤ10ʿ
#   r3˿֤ͤϤϺǸ1ʸɤФ
#--------------------------------------------------------------
get_decimal:
        subi    r1, r1, 16
        stswi   r4, r1, 16          # push r4-r7
        mflr    r7                  # save lr
        li      r3, 0
        li      r4, 10
        bl      InChar
        mr      r5, r0
        subi    r0, r5, '0          # r0 = num
    1:  mullw   r5, r3, r4          # r5 = r3 * 10
        add     r3, r0, r5          # r3 = r5 + num
        bl      InChar              # next digit
        mr      r5, r0
        subi    r0, r5, '0
        cmpwi   r0, 9
        ble     1b
        mtlr    r7                  # restore lr
        lswi    r4, r1, 16          # pop r4-r7
        addi    r1, r1, 16          # restore r1
        blr

#-------------------------------------------------------------------------
# Խդ
#   r3:Хåե, r4:ХåեƬ
#   r0 ʸ֤
#   꺸ޡȤ
#-------------------------------------------------------------------------
READ_LINE:
        LWI     r30, LINE_TOP
        lwz     r31, 0(r30)         #
        stw     r31, 4(r30)         # FLOATING_TOP = LINE_TOP

RL:
        subi    r1, r1, 24
        stswi   r3, r1, 24          # push r3-r8
        mflr    r8                  # save lr

        li      r23, 0              # 
RL_0:
        LWI     r22, HistLine       # history string ptr
        mr      r20, r4             # Input Buffer
        li      r6, 0
        stbx    r6, r20, r23        # mark EOL:InBuf[r23]=0
        mr      r21, r3             # BufferSize
        mr      r24, r23            # current position

RL_next_char:
        bl      InChar
        cmpwi   r0, 0x1B            # ESC ?
        bne     1f
        bl      translate_key_seq
    1:  cmpwi   r0, 0x09            # TAB ?
        beq     RL_tab
        cmpwi   r0, 127             # BS (linux console) ?
        beq     RL_bs
        cmpwi   r0, 0x08            # BS ?
        beq     RL_bs
        cmpwi   r0, 0x04            # ^D ?
        beq     RL_delete
        cmpwi   r0, 0x02            # ^B
        beq     RL_cursor_left
        cmpwi   r0, 0x06            # ^F
        beq     RL_cursor_right
        cmpwi   r0, 0x0E            # ^N
        beq     RL_forward
        cmpwi   r0, 0x10            # ^P
        beq     RL_backward
        cmpwi   r0, 0x0A            # enter ?
        beq     RL_in_exit
        cmpwi   r0, 0x20
        blt     RL_next_char        # illegal chars

RL_in_printable:
        mr      r3, r0
        addi    r23, r23, 1         # eol++
        addi    r24, r24, 1         # cp++
        cmplw   r23, r21            # eol < buffer size
        bge     RL_in_toolong
        cmplw   r24, r23            # eol=cp ?
        blt     RL_insert           #  No. Insert Char
        bl      OutChar             #  Yes. Display Char
        subi    r7, r24, 1          # before cursor
        stbx    r3, r20, r7         # InBuf[eol-1]=Char
        b       RL_next_char

RL_insert:
        bl      OutChar
        subi    r7, r23, 1          # p = eol-1
    1:
        cmplw   r24, r7             # while(p=>cp){buf[p]=buf[p-1]; p--}
        bgt     2f                  #   if(r24>r7) goto2
        subi    r4, r7, 1           #   r4=r7-1
        lbzx    r6, r20, r4
        stbx    r6, r20, r7
        mr      r7, r4              # r7--
        b       1b
    2:
        subi    r7, r24, 1
        stbx    r3, r20, r7         # before cursor

        bl      print_line_after_cp
        b       RL_next_char
RL_in_toolong:
        subi    r23, r23, 1
        subi    r24, r24, 1
        b       RL_next_char

RL_in_exit:
        bl      regist_history
        bl      NewLine
        mr      r0, r23             # r0 ʸ֤

        mtlr    r8                  # restore lr
        lswi    r3, r1, 24          # pop r3-r8
        addi    r1, r1, 24          # restore r1
        blr

#-------------------------------------------------------------------------
# BackSpace or Delete Character
#-------------------------------------------------------------------------
RL_bs:
        and.    r24, r24, r24       # if cp=0 then next_char
        beq     RL_next_char
        subi    r24, r24, 1         # cp--
        LWI     r3, CURSOR_LEFT
        bl      OutPString
RL_delete:
        cmpw    r24, r23            # if cp < eol then del2
        beq     RL_next_char
        subi    r23, r23, 1         # eol--
        mr      r7, r24
    1:
        cmpw    r7, r23             # while(p<eol){buf[p]=buf[p+1]; p++}
        beq     2f
        addi    r4, r7, 1
        lbzx    r3, r20, r4
        stbx    r3, r20, r7         # buf[p]=buf[p+1]
        mr      r7, r4              # p++
        b       1b
    2:
        LWI     r3, DEL_AT_CURSOR
        bl      OutPString
        b       RL_next_char

#--------------------------------------------------------------
# ʹɽ
#--------------------------------------------------------------
print_line_after_cp:
        subi    r1, r1, 12
        stswi   r3, r1, 12          # push r3-r5
        mflr    r5                  # save lr
        LWI     r3, SAVE_CURSOR
        bl      OutPString
        LWI     r3, CLEAR_EOL
        bl      OutPString
        add     r3, r24, r20        # address &InBuf[cp]
        sub     r4, r23, r24        # length = eol - cp
        bl      OutString
        LWI     r3, RESTORE_CURSOR
        bl      OutPString
        mtlr    r5                  # restore lr
        lswi    r3, r1, 12          # pop r3-r5
        addi    r1, r1, 12          # restore r1
        blr

#-------------------------------------------------------------------------
# ư
#-------------------------------------------------------------------------
RL_cursor_left:
        and.    r24, r24, r24       # if cp = 0 then next_char
        beq     RL_next_char
        subi    r24, r24, 1         # cp--
        LWI     r3, CURSOR_LEFT
        bl      OutPString
        b       RL_next_char

RL_cursor_right:
        cmpw    r23, r24            # if cp=eol then next_char
        beq     RL_next_char
        addi    r24, r24, 1         # cp++
        LWI     r3, CURSOR_RIGHT
        bl      OutPString
        b       RL_next_char

#-------------------------------------------------------------------------
# Filename Completion
#-------------------------------------------------------------------------
RL_tab:
        bl      FilenameCompletion  # ե̾䴰
        bl      DispLine
        b       RL_next_char

#-------------------------------------------------------------------------
# ҥȥ
#-------------------------------------------------------------------------
RL_forward:
        bl      regist_history      # ιԤҥȥ
        li      r3, 1
        bl      next_history
        b       RL_disp
RL_backward:
        bl      regist_history      # ιԤҥȥ
        li      r3, -1
        bl      next_history
RL_disp:
        andi.   r3, r3, 0x0F        # ҥȥ 0-15
        stw     r3, 0(r22)          # HistLine
        bl      history2input       # ҥȥ꤫ϥХåե
        bl      DispLine
        b       RL_next_char

#--------------------------------------------------------------
#  ϥХåեץץľΰ֤ɽƥϺǽ
#  entry  r20 : ϥХåեƬɥ쥹
#--------------------------------------------------------------
DispLine:
        subi    r1, r1, 12
        stswi   r3, r1, 12          # push r3-r5
        mflr    r5                  # save lr
        bl      LineTop             # Ƭ
        mr      r3, r20
        bl      OutAsciiZ           # ϥХåեɽ
        LWI     r3, CLEAR_EOL       # ޤǾõ
        bl      OutPString
        mr      r3, r20
        bl      StrLen              # <r3:ɥ쥹, >r0:ʸ
        mr      r23, r0             # ʸ
        mr      r24, r23            # ϰֹ
        mtlr    r5                  # restore lr
        lswi    r3, r1, 12          # pop r3-r5
        addi    r1, r1, 12          # restore r1
        blr

#--------------------------------------------------------------
# Ƭ˥ư(ޡ)
#--------------------------------------------------------------
LineTop:
        subi    r1, r1, 16
        stswi   r3, r1, 16          # push r3-r6
        mflr    r6                  # save lr
        LWI     r3, CURSOR_TOP
        bl      OutPString
        LWI     r3, CURSOR_RIGHT
        LWI     r5, FLOATING_TOP    # ޡ
        lwz     r4, 0(r5)
        and.    r4, r4, r4          # if 0 return
        beq     2f
    1:  bl      OutPString
        subic.  r4, r4, 1
        bne     1b
    2:
        mtlr    r6                  # restore lr
        lswi    r3, r1, 16          # pop r3-r6
        addi    r1, r1, 16          # restore r1
        blr

#--------------------------------------------------------------
# Translate Function Key into ctrl-sequence
#   return r0
#--------------------------------------------------------------
translate_key_seq:
        stwu    r3, -4(r1)          # push r3
        mflr    r3
        bl      InChar
        cmpwi   r0, '[
        beq     3f
  1:    li      r0, 0
  2:    mtlr    r3
        lwz     r3, 0(r1)           # pop r3
        addi    r1, r1, 4           # restore r1
        blr

  3:    bl      InChar
        cmpwi   r0, 'A
        bne     4f
        li      r0, 'P - 0x40       # ^P
        b       2b
  4:    cmpwi   r0, 'B
        bne     5f
        li      r0, 'N - 0x40       # ^N
        b       2b
  5:    cmpwi   r0, 'C
        bne     6f
        li      r0, 'F - 0x40       # ^F
        b       2b
  6:    cmpwi   r0, 'D
        bne     7f
        li      r0, 'B - 0x40       # ^B
        b       2b
  7:    cmpwi   r0, '3              # ^[[3~ (Del)
        beq     8f
        cmpwi   r0, '4              # ^[[4~ (End)
        bne     1b
  8:    bl      InChar
        cmpwi   r0, '~
        bne     1b
        li      r0, 4               # ^D
        b       2b

#--------------------------------------------------------------
# ϥХåեҥȥϿ
#   r20 : input buffer address
#   r22 : history string ptr
#   r23 : eol (length of input string)
#--------------------------------------------------------------
regist_history:
        subi    r1, r1, 12
        stswi   r3, r1, 12          # push r3-r5
        mflr    r5                  # save lr
        li      r3, 0
        stbx    r3, r20, r23        # write 0 at eol
        bl      check_history
        or.     r0, r0, r0
        beq     1f                  # ƱϿѤ

        lwz     r3, 4(r22)          # HistUpdate
        bl      input2history
        addi    r3, r3, 1
        andi.   r3, r3, 0x0F        # 16entry
        stw     r3, 4(r22)          # HistUpdate
        stw     r3, 0(r22)          # HistLine
    1:
        mtlr    r5                  # restore lr
        lswi    r3, r1, 12          # pop r3-r7
        addi    r1, r1, 12          # restore r1
        blr

#--------------------------------------------------------------
# ҥȥ r3 (1ޤ-1) ʤ
#    entry  : r3 = +1, -1
#    return : r3 = next entry
#--------------------------------------------------------------
next_history:
        subi    r1, r1, 20
        stswi   r4, r1, 20          # push r4-r8
        mflr    r8                  # save lr
        lwz     r7, 0(r22)          # HistLine
        li      r6, MAXHISTORY
        mr      r5, r3
    1:  subic.  r6, r6, 1           #
        blt     2f                  # ٤ƶʤ齪λ
        add     r7, r7, r5          # +/-1
        andi.   r7, r7, 0x0F        # wrap around
        mr      r3, r7              # Υȥ꡼
        bl      GetHistory          # r3 = Ƭɥ쥹
        bl      StrLen              # <r3:ɥ쥹, >r0:ʸ
        or.     r0, r0, r0
        beq     1b                  # Ԥʤ鼡
    2:
        mr      r3, r7              # ȥ꡼֤
        mtlr    r8                  # restore lr
        lswi    r4, r1, 20          # pop r4-r8
        addi    r1, r1, 20          # restore r1
        blr

#--------------------------------------------------------------
# ٤ƤΥҥȥƤɽ
#--------------------------------------------------------------
disp_history:
        subi    r1, r1, 20
        stswi   r3, r1, 20          # push r3-r7
        mflr    r7                  # save lr

        LWI     r6, HistTop
        li      r5, 0               # no. of history lines
    1:
        LWI     r4, HistLine
        lwz     r3, 0(r4)
        cmpw    r5, r3
        bne     2f
        li      r3, '*'
        b       3f
    2:  li      r3, ' '
    3:  bl      OutChar

        mr      r3, r5              # ҥȥֹ
        li      r4, 2               # 2
        bl      PrintRight0
        li      r3, ' '
        bl      OutChar
        mr      r3, r6              # ҥȥɽ
        bl      OutAsciiZ
        bl      NewLine
        addi    r6, r6, MAXLINE     # next history string
        addi    r5, r5, 1
        cmpwi   r5, MAXHISTORY
        bne     1b                  # check next
        mtlr    r7                  # restore lr
        lswi    r3, r1, 20          # pop r3-r7
        addi    r1, r1, 20          # restore r1
        blr

#--------------------------------------------------------------
# ٤ƤΥҥȥƤõ
#--------------------------------------------------------------
erase_history:
        subi    r1, r1, 16
        stswi   r3, r1, 16          # push r3-r6
        mflr    r6                  # save lr

        LWI     r5, HistTop
        li      r4, 0               # index of the history line
        li      r3, 0
    1:  stw     r3, 0(r5)           # mark eol
        addi    r5, r5, MAXLINE     # next history
        addi    r4, r4, 1
        cmpwi   r4, MAXHISTORY
        bne     1b                  # check next
        mtlr    r6                  # restore lr
        lswi    r3, r1, 16          # pop r3-r6
        addi    r1, r1, 16          # restore r1
        blr

#--------------------------------------------------------------
# ϥХåեƱƤΥҥȥХåե뤫å
#   r20 : input buffer address
#   r23 : eol (length of input string)
#   r0 : if found then return 0
#--------------------------------------------------------------
check_history:
        subi    r1, r1, 20
        stswi   r3, r1, 20          # push r3-r7
        mflr    r7                  # save lr
        LWI     r30, HistTop        # &histry[0]
        li      r5, MAXHISTORY      # no. of history lines
    1:
        li      r6, 0               # string top

    2:  lbzx    r3, r20, r6         # get a char from input buf
        lbzx    r4, r30, r6         # get a char from histry
        cmpw    r3, r4
        bne     3f                  # different char
        and.    r3, r3, r3          # eol ?
        beq     4f                  # found
        addi    r6, r6, 1           # next char
        b       2b

    3:  addi    r30, r30, MAXLINE   # next history string
        subic.  r5, r5, 1           # check all?
        bne     1b                  # check next

        li      r0, 1               # compare all, not found
        b       5f

    4:  li      r0, 0               # found
    5:  mtlr    r7                  # restore lr
        lswi    r3, r1, 20          # pop r3-r7
        addi    r1, r1, 20          # restore r1
        blr

#--------------------------------------------------------------
# ϥХåեΥǥå򥢥ɥ쥹Ѵ
#   enter  r3 : ҥȥХåեΥǥå (0..15)
#   exit   r3 : historyinput buffer top address
#--------------------------------------------------------------
GetHistory:
        subi    r1, r1, 8
        stswi   r4, r1, 8           # push r4-r5
        li      r4, MAXLINE
        LWI     r5, HistTop
        mullw   r3, r4, r3          # r0=r4*r3+HistTop
        add     r3, r3, r5
        lswi    r4, r1, 8           # pop r4-r5
        addi    r1, r1, 8           # restore r1
        blr

#--------------------------------------------------------------
# ϥХåեҥȥХåեإԡ
#   r3 : ҥȥХåեΥǥå (0..15)
#   r20 : input buffer
#--------------------------------------------------------------
input2history:
        subi    r1, r1, 16
        stswi   r3, r1, 16          # push r3-r6
        mflr    r6                  # save lr

        bl      GetHistory
        subi    r4, r20, 1          # prepare pre increment
        subi    r5, r3, 1           # prepare pre increment
        b       1f

#--------------------------------------------------------------
# ҥȥХåեϥХåեإԡ
#   r3 : ҥȥХåեΥǥå (0..15)
#   r20 : input buffer
#--------------------------------------------------------------
history2input:
        subi    r1, r1, 16
        stswi   r3, r1, 16          # push r3-r6
        mflr    r6                  # save lr
        bl      GetHistory
        subi    r4, r3, 1           # prepare pre increment
        subi    r5, r20, 1          # prepare pre increment

    1:  lbzu    r3, 1(r4)           # r3 = mem1[++r4]
        stbu    r3, 1(r5)           # mem2[++r5] = r3
        cmpwi   r3, 0
        bne     1b
        mtlr    r6                  # restore lr
        lswi    r3, r1, 16          # pop r3-r6
        addi    r1, r1, 16          # restore r1
        blr

#--------------------------------------------------------------
#  ե̾䴰ǽ
#  entry  r24 : ʸϤϥХåեΰ
#         r20 : ϥХåեƬɥ쥹
#--------------------------------------------------------------
FilenameCompletion:
        subi    r1, r1, 20
        stswi   r3, r1, 20          # push r3-r7
        mflr    r7                  # save lr
        LWI     r28, FileNameBuffer # FileNameBuffer
        LWI     r25, DirName
        LWI     r26, FNArray        # ե̾ؤΥݥ
        LWI     r27, PartialName    # ϥХåեΥݥ
        lbz     r3, 0(r20)          # Ƭʸ
        cmpwi   r3, 0               # ԤĹ0
        beq     1f
        bl      ExtractFilename     # ϥХåեѥ̾
        bl      GetDirectoryEntry   # ե̾򥳥ԡ
        bl      InsertFileName      # 䴰ϥХåե
    1:
        mtlr    r7                  # restore lr
        lswi    r3, r1, 20          # pop r3-r7
        addi    r1, r1, 20          # restore r1
        blr

#--------------------------------------------------------------
# פե̾ʣʤɽʤ٤Ĺ䴰롣
#
# פե̾ʤʤ顢<none>ϥХåե
# ˰פե̾򥳥ԡ
# ϥХåե0ɲáϤϥХåեΰ
# 򹹿. ϥХåեʸ(r24)֤
#--------------------------------------------------------------
InsertFileName:
        subi    r1, r1, 28
        stswi   r3, r1, 28          # push r3-r9
        mflr    r9                  # save lr

        cmpwi   r31, 0              # FNCount ե
        bne     aaa10
        LWI     r5, NoCompletion    # <none>ϥХåե
        b       6f                  # פե̾ʤ
   aaa10:
        lwz     r3, 0(r27)          # ʬե̾
        bl      StrLen
        mr      r30, r0             # r30 = ʬե̾Ĺ
        cmpwi   r31, 1              # ҤȤĤ?
        bne     aaa11
        lwz     r3, 0(r26)          # FNArrayƬ
        add     r5, r3, r30         # r5 = FNArray[0] + r30
        b       6f                  # ϥХåե˥ԡ
   aaa11:
        bl      ListFile            # ե뤬ʣʤɽ
        # ʣפƤʤ٤Ĺ䴰
        # ǽΥȥ꡼ȼӡ٤ƤΥȥ꡼פƤ
        # Ӥʸ1Ŀʤ롣פʤʸĤä齪
        li      r6, 0               # ɲä䴰Ǥʸ
    1:
        subi    r8, r31, 1          # ե - 1
        lwz     r3, 0(r26)          # ǽΥե̾
        add     r5, r3, r30         # r5 = FNArray[0] + ʬե̾Ĺ
        lbzx    r3, r5, r6          # r3 = (FNArray[0] + Ĺ + r6)
        mtctr   r8
        slwi    r8, r8, 2           # r8 = r8 * 4

    2:
        lwzx    r7, r26, r8         # r7 = &FNArray[r8]
        add     r7, r7, r30         # r7 = &FNArray[r8] + Ĺ
        lbzx    r4, r7, r6          # r4 = &FNArray[r8] + Ĺ + r6
        cmpw    r3, r4
        bne     3f                  # ۤʤʸȯ
        addi    r8, r8, -4          # Υե̾
        bdnz    2b                  # ٤ƤΥե̾Ƿ֤

        addi    r6, r6, 1           # ɲä䴰Ǥʸ+1
        b       1b                  # ʸ
    3:
        cmpwi   r6, 0               # ɲʸʤ
        beq     9f                  # ʣ뤬ɲ䴰Բ
    4:  # ʬŪ˥ե̾䴰
        lbz     r3, 0(r5)           # 䴰ʬ򥳥ԡ
        stbx    r3, r20, r24        # ϥХåեɲ
        subic.  r6, r6, 1
        beq     9f                  # 䴰ʬԡλ
        addi    r5, r5, 1           # ʸ
        addi    r24, r24, 1
        b       4b                  #

    6:  # Ĥפʤե̾򥳥ԡ
        lbz     r3, 0(r5)           # ե̾򥳥ԡ
        stbx    r3, r20, r24        # ϥХåեɲ
        addi    r5, r5, 1           # ʸ
        addi    r24, r24, 1
        and.    r3, r3, r3          # ʸ0ǽλ
        bne     6b

    9:  mtlr    r9                  # restore lr
        lswi    r3, r1, 28          # pop r3-r9
        addi    r1, r1, 28          # restore r1
        blr

#--------------------------------------------------------------
# ʸ󤫤ǥ쥯ȥ̾ʬե̾Ф
# Хåե DirName(r25), PartialName(r27:ݥ)˳Ǽ
# TAB줿ϥХåեκǸʸս
# 󤷤ơƬޤϥڡޤ " õ
# ƬޤϥڡθϥХåեκǸޤǤ
# ʸϤƥѥ̾(r25)ȥե̾(r27)Хåե¸
#  entry  r24 : ʸϤϥХåեΰ
#         r20 : ϥХåեƬɥ쥹
#  ctr˲
#--------------------------------------------------------------
ExtractFilename:
        subi    r1, r1, 24
        stswi   r3, r1, 24          # push r3-r8
        mflr    r8                  # save lr

        add     r5, r24, r20        # r5 = &InBuf[cp]
        mr      r4, r5
        li      r3, 0
        stb     r3, 0(r4)           # ϺѤʸޡ
        mr      r29, r28            # FNBPointer=FileNameBuffer
        li      r31, 0              # FNCount=0
    1:
                                    # ʬѥ̾Ƭܤ
        lbz     r3, 0(r4)           # ֤
        cmpwi   r3, 0x20            # ϥѥ̾ζڤ
        beq     2f                  # ʤ鼡ν
        cmpwi   r3, '"              # Űѥ̾ζڤ
        beq     2f                  # ŰǤ⼡ν
        cmpw    r4, r20             # Ƭå
        beq     3f                  # Ƭʤ鼡ν
        subi    r4, r4, 1           # ˸
        b       1b                  # ⤦Ĵ٤

    2:  addi    r4, r4, 1           # ȯΤƬ
    3:
        lbz     r3, 0(r4)
        cmpwi   r3, 0               # ʸ
        beq     8f                  # ʤ(Ĺ0)ʤ齪λ

    4:  subi    r5, r5, 1           # ϺѤʸǽɥ쥹
        lbz     r3, 0(r5)           # ˥
        cmpwi   r3, '/              # ǥ쥯ȥʬ
        bne     9f
        addi    r5, r5, 1           # ե̾/
        b       5f                  # "/"ȯ
    9:  cmpw    r4, r5              # ǥ쥯ȥʬʤ?
        bne     4b                  #
    5:                              # "/"ȯޤ̵
        li      r3, 0               # ǥ쥯ȥ̾򥳥ԡ
        stb     r3, 0(r25)          # ǥ쥯ȥ̾Хåե
        stw     r5, 0(r27)          # ʬե̾Ƭɥ쥹Ǽ
        sub.    r6, r5, r4          # r6=ǥ쥯ȥ̾ʸ
        beq     8f                  # ǥ쥯ȥʬʤ

        mtctr   r6
        subi    r7, r25, 1          # DirNameХåեƬ-1
        subi    r4, r4, 1           # ϥХåեʬѥ̾Ƭ-1
    7:
        lbzu    r3, 1(r4)           # ԡ
        stbu    r3, 1(r7)           # ǥ쥯ȥ̾Хåե
        bdnz    7b
        li      r3, 0
        stb     r3, 1(r7)           # ʸޡ
    8:
        mtlr    r8                  # restore lr
        lswi    r3, r1, 24          # pop r3-r8
        addi    r1, r1, 24          # restore r1
        blr

#-------------------------------------------------------------------------
# ǥ쥯ȥΥȥgetdentsǼ(1ĤȤϸ¤ʤΤ?)ơ
# 1ĤŤĥե/ǥ쥯ȥ̾lstatȽǤ
# ǥ쥯ȥǰפե̾ե̾Хåե˽񤭹ࡣ
#-------------------------------------------------------------------------
GetDirectoryEntry:
        subi    r1, r1, 28
        stswi   r3, r1, 28          # push r3-r9
        mflr    r9                  # save lr
        lbz     r3, 0(r25)          # ǥ쥯ȥʬκǽʸ
        and.    r3, r3, r3          # Ĺ 0 ?
        bne     5f
        LWI     r3, current_dir     # ǥ쥯ȥʬʤ
        b       6f
    5:  mr      r3, r25             # ǥ쥯ȥ̾Хåե

    6:  bl      fropen              # ǥ쥯ȥꥪץ
        bso     4f
        mr      r7, r3              # fd 
    1:                              # ǥ쥯ȥꥨȥ
        mr      r3, r7              # fd 
        LWI     r4, dir_ent         # dir_entǼƬɥ쥹
        mr      r8, r4              # r8 : dir_entؤΥݥ
        LWI     r5, size_dir_ent    # dir_entǼΰ襵
.ifdef MACOSX
.else
        li      r0, sys_getdents    # dir_entʣ֤
        sc
.endif
        bsol    CheckSysError       # ƥॳ륨顼
        or.     r3, r3, r3
        beq     4f                  # λ
        mr      r6, r3              # r6 : buffer size
    2:
        mr      r4, r8              # r8 : dir_entؤΥݥ
        bl      GetFileStat         # ե
        LWI     r4, file_stat
        lwz     r3, 8(r4)           # file_stat.st_mode
        andi.   r3, r3, O_DIRECTORY # ǥ쥯ȥ?
        addi    r4, r8, 10          # ե̾Ƭɥ쥹
        bl      CopyFilename        # פե̾

        # sys_getdents֤ȥ꤬ʣξˤϼΥե
        # 1Ĥʤ鼡Υǥ쥯ȥꥨȥ롣
        lhz     r3, 8(r8)           # rec_len 쥳Ĺ
        sub.    r6, r6, r3          # buffer_size - rec_len
        beq     1b                  # Υǥ쥯ȥꥨȥ
        add     r8, r8, r3          # Υե̾γǼΰ
        mr      r4, r8
        b       2b                  # Υե

    4:
        mr      r3, r5              # fd
        bl      fclose              # ǥ쥯ȥꥯ
        mtlr    r9                  # restore lr
        lswi    r3, r1, 28          # pop r3-r9
        addi    r1, r1, 28          # restore r1
        blr

#--------------------------------------------------------------
# DirNamedir_ent.dnamePathName
# PathNameΥեξ֤file_stat¤Τ˼
# entry
#   r4 : dir_entɥ쥹
#   r25 : DirName
#   DirName ˥ǥ쥯ȥ̾
#--------------------------------------------------------------
GetFileStat:
        subi    r1, r1, 28
        stswi   r3, r1, 28          # push r3-r9
        mflr    r9                  # save lr
        addi    r6, r4, 10          # dir_ent.d_name + x
        LWI     r5, PathName        # PathName¸ꥢ
        subi    r7, r5, 1           # PathName - 1
        mr      r3, r25             # DirNameǥ쥯ȥ̾¸ɥ쥹
        bl      StrLen              # ǥ쥯ȥ̾Ĺ>r0
        and.    r4, r0, r0
        beq     2f
                                    # ǥ쥯ȥ̾ԡ
        subi    r3, r25, 1          # DirName - 1
        mtctr   r4
    1:
        lbzu    r8, 1(r3)           # ǥ쥯ȥ̾Υԡ
        stbu    r8, 1(r7)           # PathName˽񤭹
        bdnz    1b

    2:  mr      r3, r6              # ե̾Ĺ
        bl      StrLen              # <r3:ɥ쥹, >r0:ʸ

        mtctr   r0
        subi    r6, r6, 1           # for preincrement
    3:  lbzu    r8, 1(r6)           # ե̾Υԡ
        stbu    r8, 1(r7)           # PathName˽񤭹
        bdnz    3b

        li      r0, 0
        stb     r0, 1(r7)           # ʸ(0)ޡ
        mr      r3, r5              # ѥ̾Ƭɥ쥹
        LWI     r4, file_stat       # file_statΥɥ쥹
        li      r0, sys_lstat       # եμ
        sc
        bl      CheckSysError       # ƥॳ륨顼
    4:  mtlr    r9                  # restore lr
        lswi    r3, r1, 28          # pop r3-r9
        addi    r1, r1, 28          # restore r1
        blr

#--------------------------------------------------------------
# ǥ쥯ȥǰפե̾ե̾Хåե
# (FileNameBuffer)˽񤭹
# ե̾ǥ쥯ȥ̾ʤ"/"ղä
# entry r3 : ǥ쥯ȥե饰
#       r4 : ե̾Ƭɥ쥹
#       r27 : ʬե̾Ƭɥ쥹ǼΰؤΥݥ
#--------------------------------------------------------------
CopyFilename:
        subi    r1, r1, 28
        stswi   r3, r1, 28          # push r3-r9
        mflr    r9                  # save lr
        cmplwi  r31, MAX_FILE       # r31:FNCount Ͽե
        bge     5f                  # ե>=MAX_FILEʤ齪λ

        mr      r5, r4              # ե̾Ƭɥ쥹
        mr      r8, r3              # ǥ쥯ȥե饰
        lwz     r6, 0(r27)          # r27:PartialName
    1:
        lbz     r3, 0(r6)           # ʬե̾
        addi    r6, r6, 1
        and.    r3, r3, r3          # ʸ?
        beq     2f                  # ʬե̾ϰ
        lbz     r7, 0(r4)           # ե̾
        addi    r4, r4, 1
        cmpw    r3, r7              # 1ʸ
        bne     5f                  # ۤʤнλ
        b       1b                  # ʸ

    2:  # פե̾ǼǤ뤫å
        mr      r3, r5              # ե̾Ƭɥ쥹
        bl      StrLen              # ե̾Ĺ(r0)
        mr      r6, r0              # ե̾Ĺ
        addi    r7, r6, 2           # ʸ '/#0'
        add     r7, r7, r29         # ɲûκǽ r29:FNBPointer
        cmplw   r7, r26             # FileNameBufferľ(FNArray0)
        bgt     5f                  # Хåե礭ʤ:λ

        # ե̾ХåեΥե̾Ƭɥ쥹Ͽ
        slwi    r0, r31, 2
        stwx    r29, r26, r0        # FNArray[FNCount]=FNBPointer
        addi    r31, r31, 1         # ե̾ι
        mtctr   r6                  # ե̾Ĺ
        subi    r5, r5, 1
        subi    r29, r29, 1
    3:
        lbzu    r7, 1(r5)           # ե̾Υԡ
        stbu    r7, 1(r29)
        bdnz    3b

        and.    r8, r8, r8          # ǥ쥯ȥե饰
        beq     4f
        li      r3, '/              # ǥ쥯ȥ̾ʤ"/"ղ
        stbu    r3, 1(r29)
    4:
        li      r3, 0
        stbu    r3, 1(r29)          # ѥ졼(0)
        addi    r29, r29, 1
    5:
        mtlr    r9                  # restore lr
        lswi    r3, r1, 28          # pop r3-r9
        addi    r1, r1, 28          # restore r1
        blr

#--------------------------------------------------------------
# ե̾Хåեɽ
#--------------------------------------------------------------
ListFile:
        subi    r1, r1, 20
        stswi   r3, r1, 20          # push r3-r7
        mflr    r7                  # save lr
        bl      NewLine
        li      r5, 0               # Ŀ
    1:
        slwi    r3, r5, 2
        lwzx    r6, r26, r3         # FNArray + FNCount * 4
        li      r4, 4               # 4
        mr      r3, r5
        bl      PrintRight          # ֹɽ
        li      r3, 0x20
        bl      OutChar
        mr      r3, r6
        bl      OutAsciiZ           # ե̾ɽ
        bl      NewLine
        addi    r5, r5, 1
        cmpw    r5, r31
        blt     1b
    2:
        mtlr    r7                  # restore lr
        lswi    r3, r1, 20          # pop r3-r7
        addi    r1, r1, 20          # restore r1
        blr

#-------------------------------------------------------------------------
# ե򥪡ץ
# enter   r3: 裱 filename
# return  r3: fd, if error then set Summary Overflow
# destroyed r5
#-------------------------------------------------------------------------
fropen:
        stwu    r4, -4(r1)          # push(r4)
        li      r4, O_RDONLY        # 裲 flag
        b       1f
fwopen:
        stwu    r4, -4(r1)          # push(r4)
        li      r4, O_CREAT | O_WRONLY | O_TRUNC
    1:
        li      r5, 0644            # 裳 mode
        li      r0, sys_open        # ƥॳֹ
        sc
        lwz     r4, 0(r1)           # pop(r4)
        addi    r1, r1, 4           # restore r1
        blr

#-------------------------------------------------------------------------
# ե򥯥
# enter   r3 : 裱 եǥץ
#-------------------------------------------------------------------------
fclose:
        li      r0, sys_close
        sc
        blr


#-------------------------------------------------------------------------
# ƥॳ륨顼å
#-------------------------------------------------------------------------
CheckSysError:
        subi    r1, r1, 32
        stswi   r3, r1, 32          # push r3-r10
        mflr    r10                 # save lr

.ifndef  SIMPLE_MSG
        bl      SysCallError
.else
        bns     1f
        LWI     r3, ErrorMessage
        bl      OutAsciiZ
.endif
    1:  mtlr    r10                 # restore lr
        lswi    r3, r1, 32          # pop r3-r10
        addi    r1, r1, 32          # restore r1
        blr


#==============================================================

.data
                .align      2
LINE_TOP:       .long       7       # No. of prompt characters
FLOATING_TOP:   .long       7       # Save cursor position

                .align      2
CURSOR_REPORT:  .byte       4, 0x1B
                .ascii      "[6n"           # ^[[6n
                .align      2
SAVE_CURSOR:    .byte       2, 0x1B, '7     # ^[7
                .align      2
RESTORE_CURSOR: .byte       2, 0x1B, '8     # ^[8
                .align      2
DEL_AT_CURSOR:  .byte       4, 0x1B
                .ascii      "[1P"           # ^[[1P
                .align      2
CURSOR_RIGHT:   .byte       4, 0x1B
                .ascii      "[1C"           # ^[[1C
                .align      2
CURSOR_LEFT:    .byte       4, 0x1B
                .ascii      "[1D"           # ^[[1D
                .align      2
CURSOR_TOP:     .byte       1, 0x0D
                .align      2
CLEAR_EOL:      .byte       4, 0x1B
                .ascii      "[0K"           # ^[[0K
                .align      2
CSI:            .byte       2, 0x1B, '[     # ^[[

                .align      2
NoCompletion:   .asciz  "<none>"

                .align  2
current_dir:    .asciz  "./"

                .align  2
ErrorMessage:   .asciz   "\nSysCall Error!\n"
                .align   2

#-------------------------------------------------------------------------
.section    ".bss"
                    .align  2
HistLine:           .long   0
HistUpdate:         .long   0
input:              .skip   MAXLINE

                    .align 2
HistTop:
history:            .skip   MAXLINE * MAXHISTORY

                    .align  2
DirName:            .skip   MAXLINE
PathName:           .skip   MAXLINE

                    .align  2
PartialName:        .long   1           # ʬե̾Ƭɥ쥹Ǽ
FileNameBuffer:     .skip   2048, 0     # 2kbyte for filename completion
FNArray:            .skip   MAX_FILE*4  # long* Filename[0..255]
FNBPointer:         .long   1           # FileNameBufferγǼѤߥɥ쥹+1
FNCount:            .long   1           # No. of Filenames

                    .align 2
dir_ent:                                # 256 bytesdir_entǼΰ
# de_d_ino:         .long   1           # 0
# de_d_off:         .long   1           # 4
# de_d_reclen:      .hword  1           # 8
# de_d_name:                            # 10 ǥ쥯ȥꥨȥ̾
                    .skip   256

                    .align  2
size_dir_ent  = . - dir_ent

                    .align 2
file_stat:
fs_st_dev:          .long   1           # 0  եΥǥХֹ
fs_st_ino:          .long   1           # 4  եinodeֹ
fs_st_mode:         .long   1           # 8  ȥ [ǧ]
fs_st_nlink:        .hword  1           # 12
fs___pad1:          .hword  1           # 14
fs_st_uid:          .long   1           # 16
fs_st_gid:          .long   1           # 20
fs_st_rdev:         .long   1           # 24
fs_st_size:         .long   1           # 28 ե륵(byte) [ǧ]
fs_st_blksize:      .long   1           # 32 ֥å
fs_st_blocks:       .long   1
fs_st_atime:        .long   1           # 40 եκǽ
fs___unused1:       .long   1
fs_st_mtime:        .long   1           # 48 եκǽ
fs___unused2:       .long   1
fs_st_ctime:        .long   1           # 56 inodeκǽ
fs___unused3:       .long   1
fs___unused4:       .long   1
fs___unused5:       .long   1           # 68

.endif

